# ImageSegmentation

[![][ci-img]][ci-url]
[![][pkgeval-img]][pkgeval-url]
[![][codecov-img]][codecov-url]
[![][docs-stable-img]][docs-stable-url]
[![][docs-dev-img]][docs-dev-url]

Julia package for multiple Image Segmentation Algorithms

<!-- URLS -->

[ci-img]: https://github.com/JuliaImages/ImageSegmentation.jl/actions/workflows/CI.yml/badge.svg
[ci-url]: https://github.com/JuliaImages/ImageSegmentation.jl/actions/workflows/CI.yml
[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/I/ImageSegmentation.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/report.html
[codecov-img]: https://codecov.io/github/JuliaImages/ImageSegmentation.jl/coverage.svg?branch=master
[codecov-url]: https://codecov.io/github/JuliaImages/ImageSegmentation.jl?branch=master
[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://juliaimages.org/stable
[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://juliaimages.org/latest/

"""
```
segments                = meanshift(img, spatial_radius, range_radius; iter=50, eps=0.01))
```
Segments the image using meanshift clustering. Returns a `SegmentedImage`.

Parameters:
-    img                            = input grayscale image
-    spatial_radius/range_radius    = bandwidth parameters of truncated normal kernel. Controlling the size of the kernel determines the resolution of the mode detection.
-    iter/eps                       = stopping criterion for meanshift procedure. The algorithm stops after iter iterations or if kernel center moves less than eps distance in an update step, whichever comes first.
"""
function meanshift(img::Array{CT, 2}, spatial_radius::Real, range_radius::Real; iter::Int = 50, eps::Real = 0.01) where CT

    rows, cols = size(img)
    rowbins = Int(floor(rows/spatial_radius))
    colbins = Int(floor(cols/spatial_radius))
    colorbins = Int(floor(1/range_radius))

    colorbin(x)::Int = min(floor(x/range_radius) + 1, colorbins)
    rowbin(x)::Int = min(floor(x/spatial_radius) +1, rowbins)
    colbin(x)::Int = min(floor(x/spatial_radius) +1, colbins)

    buckets = Array{Vector{CartesianIndex{2}}}(undef, rowbins, colbins, colorbins)
    for i in CartesianIndices(size(buckets))
        buckets[i]=Array{CartesianIndex{2}}(undef, 0)
    end

    for i in CartesianIndices(size(img))
        push!( buckets[rowbin(i[1]), colbin(i[2]), colorbin(img[i])], i)
    end

    function dist2(a::SVector, b::SVector)::Float64
        return ((a[1]-b[1])/spatial_radius)^2 + ((a[2]-b[2])/spatial_radius)^2 + ((a[3]-b[3])/range_radius)^2
    end

    function neighborhood_mean(pt::SVector{3, Float64})::SVector{3, Float64}
        den = 0.0
        num = SVector(0.0, 0.0, 0.0)

        R = CartesianIndices(size(buckets))
        I1, Iend = first(R), last(R)
        I = CartesianIndex(rowbin(pt[1]), colbin(pt[2]), colorbin(pt[3]))

        for J in _colon(max(I1, I-_oneunit(I)), min(Iend, I+_oneunit(I)))
            for point in buckets[J]
                if dist2(pt, SVector(point[1], point[2], img[point])) <= 1
                    num += SVector(point[1], point[2], img[point])
                    den += 1
                end
            end
        end

        return den<=0 ? pt : num/den
    end

    modes = Array{Float64}(undef, 3, rows*cols)

    for i in CartesianIndices(size(img))
        pt::SVector{3, Float64} = SVector(i[1], i[2], img[i])
        for j in 1:iter
            nextpt = neighborhood_mean(pt)
            if dist2(pt, nextpt) < eps^2
                break
            end
            pt = nextpt
        end
        modes[:, i[1] + (i[2]-1)*rows] = [pt[1]/spatial_radius, pt[2]/spatial_radius, pt[3]/range_radius]
    end

    clusters = dbscan(modes, 1.414).clusters
    num_segments = length(clusters)
    TM = meantype(CT)
    result              = similar(img, Int)
    labels              = Array(1:num_segments)
    region_means        = Dict{Int, TM}()
    region_pix_count    = Dict{Int, Int}()

    cluster_idx = 0
    for cluster in clusters
        cluster_idx += 1
        region_pix_count[cluster_idx] = cluster.size
        for index in [cluster.core_indices; cluster.boundary_indices]
            i, j = (index-1)%rows + 1, floor(Int, (index-1)/rows) + 1
            result[i, j] = cluster_idx
            region_means[cluster_idx] = get(region_means, cluster_idx, zero(TM)) + img[i, j]
        end
        region_means[cluster_idx] /= region_pix_count[cluster_idx]
    end

    return SegmentedImage(result, labels, region_means, region_pix_count)
end

@testset "core" begin

  # Accessor functions
  img = fill(1.0, (4,4))
  img[1:2,1:2] .= 2.0
  img[1:2,3:4] .= 3.0
  seg = fast_scanning(img, 0.5)

  @test labels_map(seg) == seg.image_indexmap
  @test segment_labels(seg) == seg.segment_labels
  @test segment_mean(seg) == seg.segment_means
  @test all([segment_mean(seg, i) == seg.segment_means[i] for i in keys(seg.segment_means)])
  @test segment_pixel_count(seg) == seg.segment_pixel_count
  @test all([segment_pixel_count(seg, i) == seg.segment_pixel_count[i] for i in keys(seg.segment_pixel_count)])

  img = [1 1.1 0.9 10 10.2 9.8; 1 1 1.1 4 3.8 4]
  r = fuzzy_cmeans(img, 2, 2.0)

  @test segment_labels(r) == [1,2]
  @test segment_mean(r, 1) == r.centers[:,1]
  @test segment_mean(r) == Dict(1=>r.centers[:,1], 2=>r.centers[:,2])
  @test all([segment_pixel_count(r,i) == 6 for i in 1:2])
  @test segment_pixel_count(r) == Dict(1=>6, 2=>6)

  # RAG
  img = fill(1.0, (10,10))
  img[:, 5:10] .= 2.0
  seg = fast_scanning(img, 0.5)
  g, vm = region_adjacency_graph(seg, (i,j)->sum(abs2, seg.segment_means[i]-seg.segment_means[j]))

  expectedg = SimpleWeightedGraph(2)
  add_edge!(expectedg, 1, 2, 1.0)
  expectedvm = Dict(1=>1, 2=>2)

  @test g == expectedg
  @test vm == expectedvm

  img = fill(1.0, (10,10))
  img[3:8,3:8] .= 2.0
  img[5:7,5:7] .= 3.0
  seg = fast_scanning(img, 0.5)
  g, vm = region_adjacency_graph(seg, (i,j)->1)

  expectedg = SimpleWeightedGraph(3)
  add_edge!(expectedg,1,2)
  add_edge!(expectedg,2,3)
  expectedvm = Dict(1=>1, 2=>2, 3=>3)

  @test g == expectedg
  @test vm == expectedvm

  # remove_segment
  img = fill(1.0, (10,10))
  img[1:4,:] .= 2.0
  img[:,5:10] .= 4.0
  seg = fast_scanning(img, 0.5)
  new_seg = remove_segment(seg, 1, (i,j)->(-seg.segment_pixel_count[j]))

  expected = fill(3, (10,10))
  expected[5:10,1:4] .= 2
  expected_labels = [2,3]
  expected_means = Dict(2=>1.0, 3=>68/19)
  expected_count = Dict(2=>24, 3=>76)

  @test all(label->(label in expected_labels), new_seg.segment_labels)
  @test all(label->(label in new_seg.segment_labels), expected_labels)
  @test expected_count == new_seg.segment_pixel_count
  @test all(label->(expected_means[label] ≈ new_seg.segment_means[label]), new_seg.segment_labels)
  @test new_seg.image_indexmap == expected

  new_seg = remove_segment(seg, 1, (i,j)->sum(abs2, seg.segment_means[i]-seg.segment_means[j]))

  expected = fill(3, (10,10))
  expected[:,1:4] .= 2
  expected_means = Dict(2=>1.4, 3=>4.0)
  expected_count = Dict(2=>40, 3=>60)

  @test all(label->(label in expected_labels), new_seg.segment_labels)
  @test all(label->(label in new_seg.segment_labels), expected_labels)
  @test expected_count == new_seg.segment_pixel_count
  @test all(label->(expected_means[label] ≈ new_seg.segment_means[label]), new_seg.segment_labels)
  @test new_seg.image_indexmap == expected

  remove_segment!(seg, 1, (i,j)->sum(abs2, seg.segment_means[i]-seg.segment_means[j]))

  @test all(label->(label in expected_labels), seg.segment_labels)
  @test all(label->(label in seg.segment_labels), expected_labels)
  @test expected_count == seg.segment_pixel_count
  @test all(label->(expected_means[label] ≈ seg.segment_means[label]), seg.segment_labels)
  @test seg.image_indexmap == expected

  # prune_segments
  img = fill(1.0, (10,10))
  img[3,3] = 2.0
  img[5,5] = 2.0
  img[8:9,7:8] .= 3.0
  seg = fast_scanning(img, 0.5)
  new_seg = prune_segments(seg, l->(seg.segment_pixel_count[l] < 2), (i,j)->sum(abs2, seg.segment_means[i]-seg.segment_means[j]))

  expected = fill(1, (10,10))
  expected[8:9,7:8] .= 4
  expected_labels = [1,4]
  expected_means = Dict(4=>3.0, 1=>49/48)
  expected_count = Dict(4=>4, 1=>96)

  @test all(label->(label in expected_labels), new_seg.segment_labels)
  @test all(label->(label in new_seg.segment_labels), expected_labels)
  @test expected_count == new_seg.segment_pixel_count
  @test all(label->(expected_means[label] ≈ new_seg.segment_means[label]), new_seg.segment_labels)
  @test new_seg.image_indexmap == expected

  new_seg = prune_segments(seg, [2,3], (i,j)->sum(abs2, seg.segment_means[i]-seg.segment_means[j]))

  @test all(label->(label in expected_labels), new_seg.segment_labels)
  @test all(label->(label in new_seg.segment_labels), expected_labels)
  @test expected_count == new_seg.segment_pixel_count
  @test all(label->(expected_means[label] ≈ new_seg.segment_means[label]), new_seg.segment_labels)
  @test new_seg.image_indexmap == expected

  # region_adjacency_graph
  img = fill(1.0, (10,10))
  img[4:6, 4:6] .= 0

  weight_fn(I, J) = exp(-abs(I.second - J.second)) / ((I.first[1]-J.first[1])^2 + (I.first[2]-J.first[2])^2)
  G, vertex2cartesian = region_adjacency_graph(img, weight_fn, 2)

  @test nv(G) == 100
  @test G.weights[45,46] == 1
  @test G.weights[43,44] == exp(-1)

  #test that all edges weights equal weights computed using weight_fn
  @test all(map(edge-> edge.weight == weight_fn(vertex2cartesian[edge.src]=>img[vertex2cartesian[edge.src]], vertex2cartesian[edge.dst]=>img[vertex2cartesian[edge.dst]]), edges(G)))

  #test that all edges are between nodes less than r pixels away
  @test all(map(edge-> max(abs(vertex2cartesian[edge.src][1] - vertex2cartesian[edge.dst][1]), abs(vertex2cartesian[edge.src][2] - vertex2cartesian[edge.dst][2])) <= 2 , edges(G)))

  @test region_adjacency_graph(img, weight_fn, 2) == region_adjacency_graph(img, weight_fn, CartesianIndex(2,2))

  G, vertex2cartesian = region_adjacency_graph(img, weight_fn, CartesianIndex(1,2))
  @test G.weights[45,47] == 0
  @test G.weights[45,65] != 0

  #test box_iterator
  fiter = ImageSegmentation.box_iterator((3, 3))
  center = CartesianIndex(17, 24)
  @test isa(fiter(center), CartesianIndices)
  @test minimum(fiter(center)) == CartesianIndex(16, 23)
  @test maximum(fiter(center)) == CartesianIndex(18, 25)
  
end

homogeneous(i::AbstractArray{T,N}) where {T<:Union{Colorant,Real}, N} = -(extrema(i)...) == 0

@testset "Region Splitting" begin

  # 2-d image
  img = fill(1, (8,8))
  img[1:4,1:4] .= 2

  t = region_tree(img, homogeneous)

  @test t[1,1].data == ((2,16))
  @test t[1,2].data == ((1,16))
  @test t[2,1].data == ((1,16))
  @test t[2,2].data == ((1,16))
  @test all(isleaf, [t[1,1], t[1,2], t[2,1], t[2,2]])

  seg = region_splitting(img, homogeneous)

  expected = fill(1,(8,8))
  expected[5:8,1:4] .= 2
  expected[1:4,5:8] .= 3
  expected[5:8,5:8] .= 4
  expected_labels = [1,2,3,4]
  expected_means = Dict(1=>2, 2=>1, 3=>1, 4=>1)
  expected_count = Dict(1=>16, 2=>16, 3=>16, 4=>16)

  @test all(label->(label in expected_labels), seg.segment_labels)
  @test all(label->(label in seg.segment_labels), expected_labels)
  @test expected_count == seg.segment_pixel_count
  @test all(label->(expected_means[label] ≈ seg.segment_means[label]), seg.segment_labels)
  @test seg.image_indexmap == expected


  # 3-d image
  img = fill(1, (4,4,4))
  img[3:4,3:4,3:4] .= 2

  seg = region_splitting(img, homogeneous)

  expected = fill(1,(4,4,4))
  expected[3:4,1:2,1:2] .= 2
  expected[1:2,3:4,1:2] .= 3
  expected[3:4,3:4,1:2] .= 4
  expected[1:2,1:2,3:4] .= 5
  expected[3:4,1:2,3:4] .= 6
  expected[1:2,3:4,3:4] .= 7
  expected[3:4,3:4,3:4] .= 8
  expected_labels = [1,2,3,4,5,6,7,8]
  expected_means = Dict(ntuple(i->(i=>1),7)..., 8=>2)
  expected_count = Dict(ntuple(i->(i=>8), 8)...)

  @test all(label->(label in expected_labels), seg.segment_labels)
  @test all(label->(label in seg.segment_labels), expected_labels)
  @test expected_count == seg.segment_pixel_count
  @test all(label->(expected_means[label] ≈ seg.segment_means[label]), seg.segment_labels)
  @test seg.image_indexmap == expected

end

@deprecate seeded_region_growing(
    img::AbstractArray,
    seeds::AbstractVector,
    kernel_dim::Vector{Int},
    diff_fn::Function = default_diff_fn) seeded_region_growing(img, seeds, (kernel_dim...,), diff_fn)

@deprecate unseeded_region_growing(
    img::AbstractArray,
    threshold::Real,
    kernel_dim::Vector{Int},
    diff_fn::Function = default_diff_fn) unseeded_region_growing(img, threshold, (kernel_dim...,), diff_fn)

@testset "MeanShift Segmentation" begin

    img = zeros(Gray{N0f8}, 10, 10)
    img[2:3, 2:3] .= 0.2
    img[2, 8] = 0.5
    img[5:6, 5:6] .= 0.8
    T = Gray{N0f8}
    TM = ImageSegmentation.meantype(T)

    result = meanshift(img, 8, 7/255)

    @test length(result.segment_labels) == 4
    @test result.segment_labels == collect(1:4)

    @test all(label->(label==result.image_indexmap[2,2]), result.image_indexmap[2:3, 2:3])
    @test all(label->(label==result.image_indexmap[5,5]), result.image_indexmap[5:6, 5:6])

    @test result.segment_means[result.image_indexmap[1,1]] == zero(TM)
    @test result.segment_means[result.image_indexmap[2,2]] == TM(img[2,2])
    @test result.segment_means[result.image_indexmap[2,8]] == TM(img[2,8])
    @test result.segment_means[result.image_indexmap[5,5]] == TM(img[5,5])

    @test result.segment_pixel_count[result.image_indexmap[1,1]] == 91
    @test result.segment_pixel_count[result.image_indexmap[2,2]] == 4
    @test result.segment_pixel_count[result.image_indexmap[2,8]] == 1
    @test result.segment_pixel_count[result.image_indexmap[5,5]] == 4
end

module ImageSegmentation

import Base: show

# To keep the symbols in the namespace maintainble, we try to be explicit on symbols
# importing here, especially for external symbols developed outside of JuliaImages
using LinearAlgebra, Statistics
using DataStructures, StaticArrays, ImageCore, ImageFiltering, RegionTrees, Distances, StaticArrays, Clustering
using Graphs: Edge, AbstractEdge, nv, neighbors, vertices
using Graphs: add_vertices!, add_edge!
using MetaGraphs: MetaGraph
using ImageMorphology: erode
using SimpleWeightedGraphs: SimpleWeightedGraph
using ImageCore.ColorVectorSpace: MathTypes
import Clustering: kmeans, fuzzy_cmeans

const PairOrTuple{K,V} = Union{Pair{K,V},Tuple{K,V}}

include("compat.jl")
include("core.jl")
include("region_growing.jl")
include("felzenszwalb.jl")
include("fast_scanning.jl")
include("flood_fill.jl")
include("watershed.jl")
include("region_merging.jl")
include("meanshift.jl")
include("clustering.jl")
include("merge_segments.jl")
include("deprecations.jl")

export
    #accessor methods
    labels_map,
    segment_labels,
    segment_pixel_count,
    segment_mean,

    # methods
    seeded_region_growing,
    unseeded_region_growing,
    felzenszwalb,
    fast_scanning,
    fast_scanning!,
    flood,
    flood_fill!,
    watershed,
    hmin_transform,
    region_adjacency_graph,
    remove_segment,
    remove_segment!,
    prune_segments,
    region_tree,
    region_splitting,
    meanshift,
    kmeans,
    fuzzy_cmeans,
    merge_segments,

    # types
    SegmentedImage,
    ImageEdge

@deprecate rem_segment  remove_segment
@deprecate rem_segment! remove_segment!

end # module

accum_type(::Type{T}) where {T<:Integer}    = Int
accum_type(::Type{Float32})                 = Float32
accum_type(::Type{T}) where {T<:Real}       = Float64
accum_type(::Type{T}) where {T<:FixedPoint} = floattype(T)
accum_type(::Type{C}) where {C<:Colorant}   = base_colorant_type(C){accum_type(eltype(C))}

accum_type(val) = isa(val, Type) ? throw_accum_type(val) : convert(accum_type(typeof(val)), val)
throw_accum_type(T) = error("type $T not supported in `accum_type`")

default_diff_fn(c1::CT1,c2::CT2) where {CT1<:Union{Colorant,Real}, CT2<:Union{Colorant,Real}} = sqrt(abs2(c1-accum_type(c2)))

"""
`SegmentedImage` type contains the index-label mapping, assigned labels,
segment mean intensity and pixel count of each segment.
"""
struct SegmentedImage{T<:AbstractArray,U<:Union{Colorant,Real}}
    image_indexmap::T
    segment_labels::Vector{Int}
    segment_means::Dict{Int,U}
    segment_pixel_count::Dict{Int,Int}
end

"""
    edge = ImageEdge(index1, index2, weight)

Construct an edge in a Region Adjacency Graph. `index1` and `index2` are the integers corresponding to individual pixels/voxels (in the sense of linear indexing via `sub2ind`), and `weight` is the edge weight (measures the dissimilarity between pixels/voxels).
"""
struct ImageEdge
    index1::Int
    index2::Int
    weight::Float64
end

# TODO: add methods via dispatch for accessing fields of `FuzzyCMeansResult`
# Accessor functions
"""
    img_labeled = labels_map(seg)

Return an array containing the label assigned to each pixel.
"""
labels_map(seg::SegmentedImage) = seg.image_indexmap

"""
    labels = segment_labels(seg)

Returns the list of assigned labels
"""
segment_labels(seg::SegmentedImage) = seg.segment_labels

segment_labels(r::FuzzyCMeansResult) = collect(1:size(r.centers)[2])

"""
    c = segment_pixel_count(seg, l)

Returns the count of pixels that are assigned label `l`. If no label is
supplied, it returns a Dict(label=>pixel_count) of all the labels.
"""
segment_pixel_count(seg::SegmentedImage, l::Int) = seg.segment_pixel_count[l]
segment_pixel_count(seg::SegmentedImage) = seg.segment_pixel_count

segment_pixel_count(r::FuzzyCMeansResult, l::Int) = size(r.weights)[1]
segment_pixel_count(r::FuzzyCMeansResult) = Dict([(i, segment_pixel_count(r,i)) for i in segment_labels(r)])

"""
    m = segment_mean(seg, l)

Returns the mean intensity of label `l`. If no label is supplied, it returns
a Dict(label=>mean) of all the labels.
"""
segment_mean(seg::SegmentedImage, l::Int) = seg.segment_means[l]
segment_mean(seg::SegmentedImage) = seg.segment_means

segment_mean(r::FuzzyCMeansResult, l::Int) = r.centers[:,l]
segment_mean(r::FuzzyCMeansResult) = Dict([(i, segment_mean(r,i)) for i in segment_labels(r)])

# Dispatch on show
function show(io::IO, seg::SegmentedImage)
    print(io, "Segmented Image with:\n  labels map: ", summary(labels_map(seg)), "\n  number of labels: ", length(segment_labels(seg)))
end

"""
    G, vert_map = region_adjacency_graph(seg, weight_fn)

Constructs a region adjacency graph (RAG) from the `SegmentedImage`. It returns the RAG
along with a Dict(label=>vertex) map. `weight_fn` is used to assign weights to the edges.

    weight_fn(label1, label2)

Returns a real number corresponding to the weight of the edge between label1 and label2.

"""
function region_adjacency_graph(s::SegmentedImage, weight_fn::Function)

    function neighbor_regions!(n::Set{Int}, visited::AbstractArray, s::SegmentedImage, I::CartesianIndex)
        R = CartesianIndices(axes(s.image_indexmap))
        I1 = _oneunit(CartesianIndex{ndims(visited)})
        Ibegin, Iend = first(R), last(R)
        t = Vector{CartesianIndex{ndims(visited)}}()
        push!(t, I)

        while !isempty(t)
            temp = pop!(t)
            visited[temp] = true
            for J in _colon(max(Ibegin, temp-I1), min(Iend, temp+I1))
                if s.image_indexmap[temp] != s.image_indexmap[J]
                    push!(n,s.image_indexmap[J])
                elseif !visited[J]
                    push!(t,J)
                end
            end
        end
        n
    end

    visited  = fill(false, axes(s.image_indexmap))                           # Array to mark the pixels that are already visited
    G        = SimpleWeightedGraph()                                         # The region_adjacency_graph
    vert_map = Dict{Int,Int}()                                               # Map that stores (label, vertex) pairs

    # add vertices to graph
    add_vertices!(G,length(s.segment_labels))

    # setup `vert_map`
    for (i,l) in enumerate(s.segment_labels)
        vert_map[l] = i
    end

    # add edges to graph
    for p in CartesianIndices(axes(s.image_indexmap))
        if !visited[p]
            n = Set{Int}()
            neighbor_regions!(n, visited, s, p)
            for i in n
                add_edge!(G, vert_map[s.image_indexmap[p]], vert_map[i], weight_fn(s.image_indexmap[p], i))
            end
        end
    end
    G, vert_map
end


"""
    new_seg = remove_segment(seg, label, diff_fn)

Removes the segment having label `label` and returns the new `SegmentedImage`.
For more info, see [`remove_segment!`](@ref)

"""
remove_segment(s::SegmentedImage, args...) = remove_segment!(deepcopy(s), args...)

"""
    remove_segment!(seg, label, diff_fn)

In place removal of the segment having label `label`, replacing it with the neighboring
segment having least `diff_fn` value.

    d = diff_fn(rem_label, neigh_label)

A difference measure between label to be removed and its neighbors. `isless` must be
defined for objects of the type of `d`.

# Examples

```julia
    # This removes the label `l` and replaces it with the label of
    # neighbor having maximum pixel count.
    julia> remove_segment!(seg, l, (i,j)->(-seg.segment_pixel_count[j]))

    # This removes the label `l` and replaces it with the label of
    # neighbor having the least value of euclidian metric.
    julia> remove_segment!(seg, l, (i,j)->sum(abs2, seg.segment_means[i]-seg.segment_means[j]))
```

"""
function remove_segment!(s::SegmentedImage, label::Int, diff_fn::Function)
    haskey(s.segment_means, label) || error("Label $label not present!")
    G, vert_map = region_adjacency_graph(s, (i,j)->1)
    vert_label = vert_map[label]
    neigh = neighbors(G, vert_label)

    minc = first(neigh)
    minc_val = Inf
    for i in neigh
        d = diff_fn(vert_label, s.segment_labels[i])
        if d < minc_val
            minc = i
            minc_val = d
        end
    end

    minc_label = s.segment_labels[minc]
    vert_map[label] = minc

    s.segment_pixel_count[minc_label] += s.segment_pixel_count[label]
    s.segment_means[minc_label] += (s.segment_means[label] - s.segment_means[minc_label])*s.segment_pixel_count[label]/s.segment_pixel_count[minc_label]

    for i in CartesianIndices(axes(s.image_indexmap))
        s.image_indexmap[i] = s.segment_labels[vert_map[s.image_indexmap[i]]]
    end

    delete!(s.segment_means, label)
    delete!(s.segment_pixel_count, label)
    deleteat!(s.segment_labels, vert_label)

    s
end

prune_segments(s::SegmentedImage, rem_labels::Vector{Int}, diff_fn::Function) =
    prune_segments(s, i->(i in rem_labels), diff_fn)

"""
    new_seg = prune_segments(seg, rem_labels, diff_fn)

Removes all segments that have labels in `rem_labels` replacing them with their
neighbouring segment having least `diff_fn`. `rem_labels` is a `Vector` of labels.

    new_seg = prune_segments(seg, is_rem, diff_fn)

Removes all segments for which `is_rem` returns true replacing them with their
neighbouring segment having least `diff_fn`.

    is_rem(label) -> Bool

Returns true if label `label` is to be removed otherwise false.

    d = diff_fn(rem_label, neigh_label)

A difference measure between label to be removed and its neighbors. `isless` must be
defined for objects of the type of `d`.
"""
function prune_segments(s::SegmentedImage, is_rem::Function, diff_fn::Function)

    G, vert_map = region_adjacency_graph(s, (i,j)->1)
    u = IntDisjointSets(nv(G))
    for v in vertices(G)
        if is_rem(s.segment_labels[v])
            neigh = neighbors(G, v)
            minc = first(neigh)
            minc_val = Inf
            for i in neigh
                d = diff_fn(s.segment_labels[v], s.segment_labels[i])
                if d < minc_val
                    minc = i
                    minc_val = d
                end
            end
            union!(u, minc, v)
        end
    end

    segments = Set{Int}()
    for i in 1:nv(G)
        push!(segments, find_root!(u, i))
    end

    result              =   similar(s.image_indexmap)
    labels              =   Vector{Int}()
    region_means        =   empty(s.segment_means)
    region_pix_count    =   Dict{Int, Int}()

    m_type = eltype(values(region_means))

    for i in segments
        push!(labels, i)
    end

    for p in CartesianIndices(axes(result))
        result[p] = find_root!(u, vert_map[s.image_indexmap[p]])
        region_pix_count[result[p]] = get(region_pix_count, result[p], 0) + 1
        region_means[result[p]] = get(region_means, result[p], zero(m_type)) + (s.segment_means[s.image_indexmap[p]] - get(region_means, result[p], zero(m_type)))/(region_pix_count[result[p]])
    end
    SegmentedImage(result, labels, region_means, region_pix_count)

end


"""
    box_iterator(window)

Return a function that constructs a box-shaped iterable region.

# Examples
```@repl
using ImageSegmentation # hide
fiter = ImageSegmentation.box_iterator((3, 3))
center = CartesianIndex(17, 24)
fiter(center)
```
"""
function box_iterator(window::Dims{N}) where N
    for dim in window
        dim > 0 || error("Dimensions of the window must be positive")
        isodd(dim) || error("Dimensions of the window must be odd")
    end
    halfwindow = CartesianIndex(map(x -> x ÷ 2, window))
    return function(center::CartesianIndex{N})
        _colon(center-halfwindow, center+halfwindow)
    end
end

"""
    diamond_iterator(window)

Return a function that constructs a diamond-shaped iterable region.

# Examples
```jldoctest; setup=:(using ImageSegmentation), filter=r"#\\d+"
julia> fiter = ImageSegmentation.diamond_iterator((3, 3))
#18 (generic function with 1 method)

julia> center = CartesianIndex(17, 24)
CartesianIndex(17, 24)

julia> fiter(center)
(CartesianIndex(18, 24), CartesianIndex(17, 25), CartesianIndex(16, 24), CartesianIndex(17, 23))
```
"""
function diamond_iterator(window::Dims{N}) where N
    for dim in window
        dim > 0 || error("Dimensions of the window must be positive")
        isodd(dim) || error("Dimensions of the window must be odd")
    end
    halfwindow = CartesianIndex(map(x -> x ÷ 2, window))
    return function(center::CartesianIndex{N})
        (ntuple(i -> center + CartesianIndex(ntuple(j -> i == j, N)), N)...,
         ntuple(i -> center - CartesianIndex(ntuple(j -> i == j, N)), N)...)
    end
end

window_neighbors(img::AbstractArray{T,N}) where {T,N} = ntuple(_ -> 3, N)

"""
    G, vertex2cartesian = region_adjacency_graph(img, weight_fn, R)

Constructs a region adjacency graph (RAG) from a N-D image `img`. It returns the RAG along
with a mapping from vertex index in RAG to cartesian index in the image.

`weight_fn` is used to assign weights to the edges using pixel similarity and spatial proximity,
where higher weight means greater similarity and thus stronger association. Zero weight is assigned
to edges between any pair of nodes that are more than `R` pixels apart. `R` can be specified
as a N-dimensional `CartesianIndex`. Alternatively, `R` can be an integer, in which a
N-dimensional `CartesianIndex` with value `R` along each dimension is used. `weight_fn` should have
signature -

    edge_weight = weight_fn(p1::Pair{CartesianIndex{N},T}, p2::Pair{CartesianIndex{N},T}) where {N,T}

Any graph clustering technique can be used with the constructed RAG to segment the image.

# Example

```julia
    julia> using ImageSegmentation, SimpleWeightedGraphs
    julia> img = fill(1.0, (10,10))
    julia> img[4:6, 4:6] .= 0

    julia> weight_fn(I, J) = 1-abs(I.second - J.second)
    julia> G, vertex2cartesian = region_adjacency_graph(img, weight_fn, 1)
```

"""

function region_adjacency_graph(img::AbstractArray{CT,N}, weight_fn::Function, R::CartesianIndex{N}) where {CT<:Union{Colorant,Real}, N}
    cartesian2vertex = LinearIndices(img)
    vertex2cartesian = CartesianIndices(img)

    sources = Vector{Int}()
    destinations = Vector{Int}()
    weights = Vector{Float64}()

    indices = CartesianIndices(axes(img));
    Istart, Iend = first(indices), last(indices)
    for I in indices
        for J in CartesianIndices(map((i,j)->i:j, Tuple(max(Istart, I-R)), Tuple(min(Iend, I+R))))
            if I <= J
                continue
            end
            push!(sources, cartesian2vertex[I])
            push!(destinations, cartesian2vertex[J])
            push!(weights, weight_fn(I=>img[I], J=>img[J]))
        end
    end

    G = SimpleWeightedGraph(sources, destinations, weights)

    return G, vertex2cartesian
end

region_adjacency_graph(img::AbstractArray{CT,N}, weight_fn::Function, R::Int) where {CT<:Union{Colorant,Real}, N} = region_adjacency_graph(img, weight_fn, R * CartesianIndex{N}())

function img_to_data(img::AbstractArray{T,N}) where T<:Colorant where N
    AT = accum_type(T)
    aimg = AT.(img)
    pimg = parent(aimg)
    ch = channelview(pimg)
    data = reshape(ch, :, *(size(pimg)...))
end

kmeans(img::AbstractArray{T,N}, args...; kwargs...) where {T<:Colorant,N} =
    kmeans(img_to_data(img), args...; kwargs...)

fuzzy_cmeans(img::AbstractArray{T,N}, args...; kwargs...) where {T<:Colorant,N} =
    fuzzy_cmeans(img_to_data(img), args...; kwargs...)

makebt(i) = ()
@inline makebt(i, ind, rest...) = (i & 1 != 0, makebt(i>>1, rest...)...)

makert(ind::Int, start_ind::NTuple, mid_ind::NTuple, end_ind::NTuple) = ()
@inline makert(ind::Int, start_ind::NTuple, mid_ind::NTuple, end_ind::NTuple, b::Bool, rest...) =
    (b ? (mid_ind[ind]+1:end_ind[ind]) : (start_ind[ind]:mid_ind[ind]), makert(ind+1, start_ind, mid_ind, end_ind, rest...)...)

function region_tree!(rtree::Cell, img::AbstractArray{T,N}, homogeneous::Function) where T<:Union{Colorant, Real} where N

    if *(length.(axes(img))...) == 0
        return rtree
    end

    if homogeneous(img)
        m = mean(img)
        c = length(img)
        rtree.data = ((m,c))
        return rtree
    end

    split!(rtree)
    start_ind = first(CartesianIndices(axes(img))).I
    end_ind = last(CartesianIndices(axes(img))).I
    mid_ind = (start_ind.+end_ind).÷2

    for i in 0:2^N-1
        bt = makebt(i, start_ind...)
        rt = makert(1, start_ind, mid_ind, end_ind, bt...)
        region_tree!(rtree[(Int.(bt) .+ 1)...], view(img, rt...), homogeneous)
    end
    rtree
end

"""
    t = region_tree(img, homogeneous)

Creates a region tree from `img` by splitting it recursively until
all the regions are homogeneous.

    b = homogeneous(img)

Returns true if `img` is homogeneous.

# Examples

```jldoctest; setup = :(using ImageCore, ImageMorphology, ImageSegmentation)
julia> img = 0.1*rand(6, 6);

julia> img[4:end, 4:end] .+= 10;

julia> function homogeneous(img)
           min, max = extrema(img)
           max - min < 0.2
       end
homogeneous (generic function with 1 method)

julia> t = region_tree(img, homogeneous);
```

"""
region_tree(img::AbstractArray{T,N}, homogeneous::Function) where {T<:Union{Colorant, Real},N} =
    region_tree!(Cell(SVector(first(CartesianIndices(axes(img))).I), SVector(length.(axes(img))), (0.,0)), img, homogeneous)

function fill_recursive!(seg::SegmentedImage, image_indexmap::AbstractArray{Int,N}, lc::Int, rtree::Cell)::Int where N

    if *(length.(axes(image_indexmap))...) == 0
        return lc
    end

    if isleaf(rtree)
        fill!(image_indexmap, lc)
        push!(seg.segment_labels, lc)
        seg.segment_means[lc] = rtree.data[1]
        seg.segment_pixel_count[lc] = rtree.data[2]
        return lc+1
    end

    start_ind = first(CartesianIndices(axes(image_indexmap))).I
    end_ind = last(CartesianIndices(axes(image_indexmap))).I
    mid_ind = (start_ind.+end_ind).÷2

    bv = MVector{N,Bool}(undef)
    rv = MVector{N,UnitRange{Int64}}(undef)
    for i in 0:2^N-1
        bt = makebt(i, start_ind...)
        rt = makert(1, start_ind, mid_ind, end_ind, bt...)
        lc = fill_recursive!(seg, view(image_indexmap, rt...), lc, rtree[(Int.(bt) .+ 1)...])
    end
    lc
end

"""
    seg = region_splitting(img, homogeneous)

Segments `img` by recursively splitting it until all the segments
are homogeneous.

    b = homogeneous(img)

Returns true if `img` is homogeneous.

# Examples

```jldoctest; setup = :(using ImageCore, ImageMorphology, ImageSegmentation)
julia> img = 0.1*rand(6, 6);

julia> img[4:end, 4:end] .+= 10;

julia> function homogeneous(img)
           min, max = extrema(img)
           max - min < 0.2
       end
homogeneous (generic function with 1 method)

julia> seg = region_splitting(img, homogeneous);
```

"""
function region_splitting(img::AbstractArray{T,N}, homogeneous::Function) where T<:Union{Colorant, Real} where N
    rtree = region_tree(img, homogeneous)
    seg = SegmentedImage(similar(img, Int), Vector{Int}(), Dict{Int, meantype(T)}(), Dict{Int, Int}())
    lc = 1
    lc = fill_recursive!(seg, seg.image_indexmap, lc, rtree)
    seg
end

using ImageSegmentation, ImageCore, ImageFiltering, Test, StaticArrays, DataStructures
using RegionTrees: isleaf, Cell, split!
using Graphs
using MetaGraphs: MetaGraph, clear_props!, get_prop, has_prop, set_prop!, props, vertices
using SimpleWeightedGraphs

using Documenter
Base.VERSION >= v"1.6" && doctest(ImageSegmentation, manual = false)
@test isempty(detect_ambiguities(ImageSegmentation))

include("core.jl")
include("region_growing.jl")
include("felzenszwalb.jl")
include("fast_scanning.jl")
include("flood_fill.jl")
include("watershed.jl")
include("region_merging.jl")
include("meanshift.jl")
include("merge_segments.jl")

using ImageSegmentation
using ImageSegmentation.Colors
using ImageSegmentation.FixedPointNumbers
using FileIO
using Statistics
using SparseArrays
using Test

@testset "flood_fill" begin
    # 0d
    a = reshape([true])
    @test flood(identity, a, CartesianIndex()) == a
    @test_throws ArgumentError flood(!, a, CartesianIndex())
    # 1d
    a = 1:7
    @test flood(==(2), a, CartesianIndex(2)) == (a .== 2)
    @test_throws ArgumentError flood(==(2), a, CartesianIndex(3))
    @test flood(x -> 1 < x < 4, a, CartesianIndex(2)) == [false, true, true, false, false, false, false]
    @test flood(isinteger, a, CartesianIndex(2)) == trues(7)
    # 2d
    ab = [true false false false;
         true true false false;
         true false false true;
         true true true true]
    an0f8 = N0f8.(ab)
    agray = Gray.(an0f8)
        for (f, a) in ((identity, ab), (==(1), an0f8), (==(1), agray))
        for idx in CartesianIndices(a)
            if f(a[idx])
                @test flood(f, a, idx) == a
            else
                @test_throws ArgumentError flood(f, a, idx)
            end
        end
    end
    @test flood(identity, ab, Int16(1)) == ab
    # 3d
    k = 10
    a = falses(k, k, k)
    idx = CartesianIndex(1,1,1)
    incs = [CartesianIndex(1,0,0), CartesianIndex(0,1,0), CartesianIndex(0,0,1)]
    a[idx] = true
    while any(<(k), Tuple(idx))
        d = rand(1:3)
        idx += incs[d]
        idx = min(idx, CartesianIndex(k,k,k))
        a[idx] = true
    end
    for idx in eachindex(a)
        if a[idx]
            @test flood(identity, a, idx) == a
        else
            @test_throws ArgumentError flood(identity, a, idx)
        end
    end
    # Colors
    path = download("https://github.com/JuliaImages/juliaimages.github.io/raw/source/docs/src/pkgs/segmentation/assets/flower.jpg")
    img = load(path)
    seg = flood(img, CartesianIndex(87,280); thresh=0.3)
    @test 0.2*length(seg) <= sum(seg) <= 0.25*length(seg)
    c = mean(img[seg])
    # N0f8 makes for easier approximate testing
    @test N0f8(red(c)) ≈ N0f8(0.855)
    @test N0f8(green(c)) ≈ N0f8(0.161)
    @test N0f8(blue(c)) ≈ N0f8(0.439)

    # flood_fill!
    near3(x) = round(Int, x) == 3
    a0 = [range(2, 4, length=9);]
    a = copy(a0)
    idx = (length(a)+1)÷2
    dest = fill!(similar(a, Bool), false)
    @test flood_fill!(near3, dest, a, idx) == (round.(a) .== 3)
    a = copy(a0)
    flood_fill!(near3, a, idx; fillvalue=-1)
    @test a == [near3(a0[i]) ? -1 : a[i] for i in eachindex(a)]
    a = copy(a0)
    @test_throws ArgumentError flood_fill!(near3, a, idx; fillvalue=-1, isfilled=near3)
    # warning
    a = [1:7;]
    @test_logs (:warn, r"distinct.*incomplete") flood_fill!(<(5), a, 1; fillvalue=3)
    @test a == [3,3,3,4,5,6,7]
    a = [1:7;]
    dest = fill(-1, size(a))
    @test_logs flood_fill!(<(5), dest, a, 1; fillvalue=3)   # no warnings
    @test dest == [3,3,3,3,-1,-1,-1]
    a = [1:7;]
    @test_logs flood_fill!(<(5), a, 1; fillvalue=11)
    @test a == [11,11,11,11,5,6,7]

    # This mimics a "big data" application in which we have several structures we want
    # to label with different segment numbers, and the `src` array is too big to fit
    # in memory.
    # It would be better to use a package like SparseArrayKit, which allows efficient
    # insertions and supports arbitrary dimensions.
    a = Bool[0 0 0 0 0 0 1 1;
             1 1 0 0 0 0 0 0]
    dest = spzeros(Int, size(a)...)   # stores the nonzero indexes in a Dict
    flood_fill!(identity, dest, a, CartesianIndex(2, 1); fillvalue=1)
    flood_fill!(identity, dest, a, CartesianIndex(1, 7); fillvalue=2)
    @test dest == [0 0 0 0 0 0 2 2;
                   1 1 0 0 0 0 0 0]
end

"""
    seg2 = merge_segments(seg, threshold)

Merges segments in a [`SegmentedImage`](@ref) by building a region adjacency
graph (RAG) and merging segments connected by edges with weight less than 
`threshold`.

# Arguments:
* `seg`         : SegmentedImage to be merged.
* `threshold`   : Upper bound of the adjacent segment color difference to 
                  consider merging segments.

# Citation:
Vighnesh Birodkar
"Hierarchical merging of region adjacency graphs"
https://vcansimplify.wordpress.com/2014/08/17/hierarchical-merging-of-region-adjacency-graphs/
"""
function merge_segments(seg::SegmentedImage, threshold::Number)::SegmentedImage
    g = seg_to_graph(seg)

    # Populate a heap of all the edges, and a Bool indicating whether the edge
    # is valid. All edges are initially valid. The reason for this is that heap
    # removal would be expensive, so instead, we invalidate the edge entry in the
    # heap. 
    function weight(t::Tuple{Edge{Int}, Bool})::Real
        return has_prop(g, t[1], :weight) ?  get_prop(g, t[1], :weight) : 0
    end
    
    edge_heap = MutableBinaryHeap{Tuple{Edge{Int}, Bool}}(Base.By(weight),
        [(e, true) for e in edges(g)]
    )
    sizehint!(edge_heap, 3 * length(edge_heap))  # Overkill, or not enough?
    for n in edge_heap.nodes
        set_prop!(g, n.value[1], :handle, n.handle)
    end

    # Merge all edges less than threshold
    while !isempty(edge_heap) && weight(first(edge_heap)) < threshold
        e, valid = pop!(edge_heap)
        if valid
            # Invalidate all edges touching this edge.
            invalidate_neighbors!(edge_heap, g, e)

            # Merge the two nodes into one (keep e.dst, obsolete e.src)
            merge_node_props!(g, e)

            # Make new edges to the merged node.
            new_edges = add_neighboring_edges!(g, e)

            # Remove edges to src. 
            # Don't call rem_vertex!(g, e.src); it would renumber all vertices. 
            for n in collect(neighbors(g, e.src))
                rem_edge!(g, e.src, n)
            end

            # Add new edges to heap.
            for e in new_edges
                handle = push!(edge_heap, (e, true))
                set_prop!(g, e, :handle, handle)
            end
        end
    end

    return resegment(seg, g)
end


"""
    g = seg_to_graph(seg)

Given a [`SegmentedImage`](@ref), produces a region adjacency [`MetaGraph`](@ref) 
and stores segment metadata on the vertices. Edge weight is determined by
color difference.

# Arguments:
* `seg`         : a [`SegmentedImage`](@ref)
"""
function seg_to_graph(seg::SegmentedImage)::MetaGraph
    weight(i, j) = colordiff(segment_mean(seg, i), segment_mean(seg, j))
    rag, _ = region_adjacency_graph(seg, weight)

    g = MetaGraph(rag)
    for v in vertices(rag)
        set_prop!(g, v, :labels, [v])
        set_prop!(g, v, :pixel_count, seg.segment_pixel_count[v])
        set_prop!(g, v, :mean_color, seg.segment_means[v])
        set_prop!(g, v, :total_color, seg.segment_means[v] * seg.segment_pixel_count[v])
    end

    for e in edges(rag)
        set_prop!(g, Edge(e.src, e.dst), :weight, e.weight)
    end
    return g
end


"""
    seg2 = resegment(seg1, rag)

Takes a segmentation and a region adjacency graph produced by `merge_segments`
and produces an segmentation that corresponds to the graph.

# Arguments:
* `seg`         : a [`SegmentedImage`](@ref)
* `g`           : a [`MetaGraph`](@ref) representing a merged Region Adjacency 
                  Graph
"""
function resegment(seg::SegmentedImage, g::MetaGraph)::SegmentedImage
    # Find all the vertices of g that remain post-merge.
    remaining = collect(filter(v -> 0 < length(props(g, v)), vertices(g)))

    px_labels = copy(seg.image_indexmap)
    # Re-label all pixels with the vertex they were merged to.
    for v in remaining
        labels = get_prop(g, v, :labels)
        for l in labels
            if l != v
                ix = findall(x -> x == l, px_labels)
                px_labels[ix] .= v
            end
        end
    end 

    # Re-number our labels so that they are dense (no gaps) and
    # construct the other objects SegmentedImage needs.
    means, px_counts = Dict{Int, Colorant}(), Dict{Int, Int}() 
    for (i, v) in enumerate(remaining)
        ix = findall(x -> x == v, px_labels)
        px_labels[ix] .= i
        means[i] = get_prop(g, v, :mean_color)
        px_counts[i] = get_prop(g, v, :pixel_count)
    end

    labels = collect(1:length(remaining))

    return SegmentedImage(px_labels, labels, means, px_counts)
end


"""
    merge_node_props!(g, e)

Takes edge `e` in [`MetaGraph`](@ref) `g` and merges the props from its `src`
and `dst` into its `dst`, clearing all props from `src`.

"""
function merge_node_props!(g::MetaGraph, e::AbstractEdge)
    src, dst = e.src, e.dst
    clr = get_prop(g, dst, :total_color) + get_prop(g, src, :total_color)
    npx = get_prop(g, dst, :pixel_count) + get_prop(g, src, :pixel_count)

    set_prop!(g, dst, :total_color, clr)
    set_prop!(g, dst, :pixel_count, npx)
    set_prop!(g, dst, :mean_color, clr / npx)
    set_prop!(g, dst, :labels, vcat(
         get_prop(g, src, :labels),
         get_prop(g, dst, :labels)
    ))

    # Clear props on the now unused node src, to make its obsolescence clear.
    clear_props!(g, src)
end


"""
    new_edges = add_neighboring_edges!(g, e)

Finds the nodes neighboring `e` in graph `g`, creates edges from them to its 
`dst`, and  sets the weight of the new edges.

# Arguments:
* `g`         : a [`MetaGraph`](@ref)
* `e`         : an [`AbstractEdge`](@ref)
"""
function add_neighboring_edges!(g::MetaGraph, e::AbstractEdge)
    edges = Edge{eltype(e)}[]
    edge_neighbors = union(Set(neighbors(g, e.src)), Set(neighbors(g, e.dst)))
    for n in setdiff(edge_neighbors, e.src, e.dst) 
        edge = Edge(e.dst, n)
        add_edge!(g, edge)
        set_prop!(g, edge, :weight, _weight_mean_color(g, edge))
        push!(edges, edge)
    end

    return edges
end


"""
    invalidate_neighbors!(edge_heap, g, e)

Finds the neighbors of `e` in graph `g` and invalidates them in `edge_heap`.

# Arguments:
* `edge_heap` : a [`MutableBinaryHeap`](@ref)
* `g`         : a [`MetaGraph`](@ref)
* `e`         : an [`AbstractEdge`](@ref)
"""
function invalidate_neighbors!(edge_heap::MutableBinaryHeap, g::MetaGraph, e::AbstractEdge)
    function invalidate(src, dst)
        for n in setdiff(Set(neighbors(g, src)), dst)
            edge = Edge(src, n)
            h = get_prop(g, edge, :handle)
            update!(edge_heap, h, (edge, false))
        end
    end
    invalidate(e.src, e.dst)
    invalidate(e.dst, e.src)
end


"""
    weight = _weight_mean_color(g, v1, v2))

Compute the weight of an edge in [`MetaGraph`](@ref) `g` as the difference 
in mean colors of each vertex.

# Arguments:
* `g`         : a [`MetaGraph`](@ref)
* `e`         : an [`AbstractEdge`](@ref)
"""
function _weight_mean_color(g::MetaGraph, e::AbstractEdge)::Real
    return colordiff(
        get_prop(g, e.src, :mean_color), 
        get_prop(g, e.dst, :mean_color)
    )
end

"""
    index_map, num_segments = felzenszwalb(edges, num_vertices, k, min_size=0)

Segment an image represented as Region Adjacency Graph(RAG) using Felzenszwalb's segmentation algorithm. Each pixel/region
corresponds to a node in the graph and weights on each edge measure the dissimilarity between pixels.
The function returns the number of segments and index mapping from nodes of the RAG to segments.

Parameters:
- `edges`:        Array of edges in RAG. Each edge is represented as `ImageEdge`.
- `num_vertices`: Number of vertices in RAG
- `k`:            Threshold for region merging step. Larger threshold will result in bigger segments.
- `min_size`:     Minimum segment size (in # pixels)
"""
function felzenszwalb(edges::Array{ImageEdge}, num_vertices::Int, k::Float64, min_size::Int = 0)

    num_edges = length(edges)
    G = IntDisjointSets(num_vertices)
    set_size = ones(num_vertices)
    threshold = fill(convert(Float64,k), num_vertices)

    sort!(edges, lt = (x,y)->(x.weight<y.weight))

    for edge in edges
        w = edge.weight
        a = find_root!(G, edge.index1)
        b = find_root!(G, edge.index2)
        if a!=b
            if w <= min(threshold[a], threshold[b])
                merged_root = union!(G, a, b)
                set_size[merged_root] = set_size[a] + set_size[b]
                threshold[merged_root] = w + k/set_size[merged_root]
            end
        end
    end

    #merge small segments
    for edge in edges
        a = find_root!(G, edge.index1)
        b = find_root!(G, edge.index2)
        if a!=b && (set_size[a] < min_size || set_size[b] < min_size)
            union!(G, a, b)
        end
    end

    segments = OrderedSet{Int}()
    for i in 1:num_vertices
        push!(segments, find_root!(G, i))
    end

    num_sets = length(segments)
    segments2index = Dict{Int, Int}()
    for (i, s) in enumerate(segments)
        segments2index[s] = i
    end

    index_map = Vector{Int}(undef, num_vertices)
    for i in 1:num_vertices
        index_map[i] = segments2index[find_root!(G, i)]
    end

    return index_map, num_sets
end
felzenszwalb(edges::Array{ImageEdge}, num_vertices::Integer, k::Real, min_size::Integer = 0) =
    felzenszwalb(edges, convert(Int, num_vertices)::Int, convert(Float64, k)::Float64, convert(Int, min_size)::Int)

meantype(::Type{T}) where T = typeof(zero(accum_type(T))/2)

"""
    segments = felzenszwalb(img, k, [min_size])

Segment an image using Felzenszwalb's segmentation algorithm and returns the result as `SegmentedImage`.
The algorithm uses euclidean distance in color space as edge weights for the region adjacency graph.

Parameters:
- `img`:      input image
- `k`:        Threshold for region merging step. Larger threshold will result in bigger segments.
- `min_size`: Minimum segment size (in # pixels)
"""
function felzenszwalb(img::AbstractArray{T}, k::Real, min_size::Int = 0) where T<:Union{Real,Color}

    sz = size(img)
    num_vertices = prod(sz)

    R = CartesianIndices(img)
    L = LinearIndices(img)
    Ibegin, Iend = first(R), last(R)
    I1 = _oneunit(Ibegin)

    # Compute the number of entries per pixel (other than at the image edges)
    num_edges = 0
    for I in _colon(-I1, I1)
        I >= zero(I1) && continue
        num_edges += 1
    end
    num_edges *= num_vertices   # now the number for the whole image
    edges = Vector{ImageEdge}(undef, num_edges)

    num = 0
    for I in R
        imgI = img[I]
        for J in _colon(max(Ibegin, I-I1), min(Iend, I+I1))
            if I >= J
                continue
            end
            edges[num+=1] = ImageEdge(L[I], L[J], sqrt(abs2(imgI-meantype(T)(img[J]))))
        end
    end
    deleteat!(edges, num+1:num_edges)   # compensate for the ones we were missing at the image edges

    index_map, num_segments = felzenszwalb(edges, num_vertices, k, min_size)

    result              = similar(img, Int)
    labels              = Array(1:num_segments)
    region_means        = Dict{Int, meantype(T)}()
    region_pix_count    = Dict{Int, Int}()

    for I in R
        result[I] = index_map[L[I]]
        region_pix_count[result[I]] = get(region_pix_count, result[I], 0) + 1
        region_means[result[I]] = get(region_means, result[I], zero(meantype(T))) + (img[I] - get(region_means, result[I], zero(meantype(T))))/region_pix_count[result[I]]
    end

    return SegmentedImage(result, labels, region_means, region_pix_count)
end

@testset "Fast scanning" begin
  # 2-D array
  img = zeros(Float64, 9, 9)
  img[4:6,:] .= 10
  img[:,4:6] .= 11

  seg = fast_scanning(img, 2)
  expected = fill(4,(9,9))
  expected[1:3,1:3] .= 1
  expected[1:3,7:9] .= 5
  expected[7:9,1:3] .= 3
  expected[7:9,7:9] .= 6
  expected_labels = [1,3,4,5,6]
  expected_means = Dict(1=>0.0,3=>0.0,4=>10.6,5=>0.0,6=>0.0)
  expected_count = Dict(1=>9,3=>9,4=>45,5=>9,6=>9)

  @test all(label->(label in expected_labels), seg.segment_labels)
  @test all(label->(label in seg.segment_labels), expected_labels)
  @test expected_count == seg.segment_pixel_count
  @test all(label->(expected_means[label] ≈ seg.segment_means[label]), seg.segment_labels)
  @test seg.image_indexmap == expected

  # Offset array
  img = centered(img)

  seg = fast_scanning(img, 2)
  expected = centered(expected)

  @test all(label->(label in expected_labels), seg.segment_labels)
  @test all(label->(label in seg.segment_labels), expected_labels)
  @test expected_count == seg.segment_pixel_count
  @test all(label->(expected_means[label] ≈ seg.segment_means[label]), seg.segment_labels)
  @test seg.image_indexmap == expected

  # 3-D array
  img = zeros(Float64, (7,7,7))
  img[3:5,2:6,1:3] .= 2
  img[1:4,5:7,2:6] .= 3
  img[3:5,3:5,3:5] .= 8

  seg = fast_scanning(img, 1.5)
  expected = fill(5, (7,7,7))
  expected[3:5,2:6,1:3] .= 3
  expected[1:4,5:7,2:6] .= 3
  expected[3:5,3:5,3:5] .= 4
  expected_labels = [3,4,5]
  expected_means = Dict(3=>222/84,4=>8.0,5=>0.0)
  expected_count = Dict(3=>84,4=>27,5=>232)

  @test all(label->(label in expected_labels), seg.segment_labels)
  @test all(label->(label in seg.segment_labels), expected_labels)
  @test expected_count == seg.segment_pixel_count
  @test all(label->(expected_means[label] ≈ seg.segment_means[label]), seg.segment_labels)
  @test seg.image_indexmap == expected

  # custom diff_fn
  img = zeros(RGB{N0f8}, (3,3))
  img[2,:] .= RGB{N0f8}(0.2, 0.4, 0.4)
  img[3,:] .= RGB{N0f8}(0.2, 1.0, 1.0)

  seg = fast_scanning(img, 0.22)
  expected = ones(Int, (3,3))
  expected[2,:] .= 2
  expected[3,:] .= 3
  expected_labels = [1,2,3]
  expected_means = Dict(1=>RGB{Float64}(0.0,0.0,0.0),2=>RGB{Float64}(0.2,0.4,0.4),3=>RGB{Float64}(0.2,1.0,1.0))
  expected_count = Dict(1=>3,2=>3,3=>3)

  @test all(label->(label in expected_labels), seg.segment_labels)
  @test all(label->(label in seg.segment_labels), expected_labels)
  @test expected_count == seg.segment_pixel_count
  @test all(label->(expected_means[label] ≈ seg.segment_means[label]), seg.segment_labels)
  @test seg.image_indexmap == expected

  seg = fast_scanning(img, 0.22, (i,j)->(abs(i.r-j.r)))
  expected = ones(Int, (3,3))
  expected_labels = [1]
  expected_means = Dict(1=>RGB{Float64}(1.2/9,4.2/9,4.2/9))
  expected_count = Dict(1=>9)

  @test all(label->(label in expected_labels), seg.segment_labels)
  @test all(label->(label in seg.segment_labels), expected_labels)
  @test expected_count == seg.segment_pixel_count
  @test all(label->(expected_means[label] ≈ seg.segment_means[label]), seg.segment_labels)
  @test seg.image_indexmap == expected

  # Adaptive Thresholding
  img = [ 0.0 0.1 0.7 0.9;
          0.0 0.1 0.7 0.9;
          0.2 0.3 0.7 0.9;
          0.2 0.3 0.7 0.9; ]

  seg = fast_scanning(img, [0.2 0.1; 0.1 0.3])
  expected =  [ 1 1 4 4;
                1 1 4 4;
                2 2 4 4;
                2 2 4 4; ]
  expected_labels = [1,2,4];
  expected_means = Dict(1=>0.05,2=>0.25,4=>0.8)
  expected_count = Dict(1=>4,2=>4,4=>8)

  @test all(label->(label in expected_labels), seg.segment_labels)
  @test all(label->(label in seg.segment_labels), expected_labels)
  @test expected_count == seg.segment_pixel_count
  @test all(label->(expected_means[label] ≈ seg.segment_means[label]), seg.segment_labels)
  @test seg.image_indexmap == expected

  seg = fast_scanning(img, (2,2))
  expected =  [ 1 3 5 6;
                1 3 5 6;
                2 4 5 6;
                2 4 5 6; ]
  expected_labels = [1,2,3,4,5,6]
  expected_means = Dict(1=>0.0,2=>0.2,3=>0.1,4=>0.3,5=>0.7,6=>0.9)
  expected_count = Dict(1=>2,2=>2,3=>2,4=>2,5=>4,6=>4)

  @test all(label->(label in expected_labels), seg.segment_labels)
  @test all(label->(label in seg.segment_labels), expected_labels)
  @test expected_count == seg.segment_pixel_count
  @test all(label->(expected_means[label] ≈ seg.segment_means[label]), seg.segment_labels)
  @test seg.image_indexmap == expected
end

include("../src/merge_segments.jl")

@testset "SegmentedImage Merge" begin
    # Set up 3 variables: test_graph, img, seg for use in tests
    g = MetaGraph(6)

    for v in 1:6
       set_prop!(g, v, :total_color, v)
       set_prop!(g, v, :pixel_count, v)
       set_prop!(g, v, :mean_color, Gray(Float64(v)))
       set_prop!(g, v, :labels, v)
    end

    for i in 1:5
       add_edge!(g, i, i+1, :weight, i + i + 1)
    end

    img = fill(1.0, (10, 10))
    img[:, 5:10] .= 2.0
    img = map(Gray, img)
    seg = fast_scanning(img, 0.5)
    test_graph = copy(g)
    # end setup

    # Test 1. Merge 2 nodes
    g = copy(test_graph)
    merge_node_props!(g, Edge(1, 2))

    # Check that labels got properly merged
    @test sort(get_prop(g, 2, :labels)) == [1, 2]

    # Check that the other node props were properly updated
    @test get_prop(g, 2, :total_color) ==  3
    @test get_prop(g, 2, :pixel_count) ==  3
    @test get_prop(g, 2, :mean_color) == 1

    # Ensure props were cleared
    @test length(props(g, 1)) == 0

    # Ensure no weights were affected.
    for v in 1:5
        @test get_prop(g, Edge(v, v+1), :weight) == (v + v + 1)
    end

    # Test 2. Merge all nodes
    g = copy(test_graph)
    for i in 1:5
        merge_node_props!(g, Edge(i, i+1))
    end

    @test sort(get_prop(g, 6, :labels)) == 1:6
    @test get_prop(g, 6, :total_color) ==  sum(1:6)
    @test get_prop(g, 6, :pixel_count) ==  sum(1:6)
    @test get_prop(g, 6, :mean_color) == 1

    for i in 1:5
        @test length(props(g, i)) == 0
    end

    # Test 3. add_neighboring_edges!
    g = copy(test_graph)
    add_edge!(g, 1, 6, :weight, 7)  # setup

    added = add_neighboring_edges!(g, Edge(1, 2))

    @test length(added) == 2
    @test has_edge(g, Edge(2, 3))
    @test has_edge(g, Edge(2, 6))

    # Test 4. seg to graph 
    g = seg_to_graph(seg)
    @test length(edges(g)) == 1
    @test length(vertices(g)) == 2
    @test has_edge(g, Edge(1, 2))
    @test haskey(props(g, Edge(1, 2)), :weight)
    @test get_prop(g, Edge(1, 2), :weight) ≈ Colors.colordiff(1.0, 2.0)


    # Test 5. resegment
    g = seg_to_graph(seg)

    # identity resegment
    seg2 = resegment(seg, g)
    for f in [labels_map, segment_labels, segment_pixel_count, segment_mean]
        @test f(seg2) == f(seg)
    end


    # Test 6. merge
    seg2 = merge_segments(seg, 40)  # 40 > colordiff(1.0, 2.0)
    @test segment_labels(seg2) == [1]
end

using ImageFiltering

@testset "watershed" begin

    img = zeros(100, 100)
    img[25:75, 25:75] .= 1
    img[26:74, 26:74] .= 0

    markers = zeros(Int, size(img))
    markers[1, 1] = 1
    markers[50, 50] = 2

    @testset "classic watershed" begin
        # with classic watershed, we expect the top left label should spread around
        # the center label.
        result = watershed(img, markers)

        @test length(result.segment_labels) == 2
        @test result.segment_labels == collect(1:2)
        @test all(label->(label==result.image_indexmap[50,50]), result.image_indexmap[26:74,26:74])
    end

    @testset "masked watershed" begin
        mask = trues(size(img))
        mask[60:70, 60:70] .= false

        result = watershed(img, markers, mask=mask)
        labels = labels_map(result)

        # where the mask is false, no label should be assigned
        @test sum(labels[.~ mask]) == 0

        result = watershed(img, markers, compactness=10.0, mask=mask)
        labels = labels_map(result)

        # where the mask is false, no label should be assigned
        @test sum(labels[.~ mask]) == 0
    end

    @testset "compact watershed" begin
        result = watershed(img, markers, compactness=10.0)
        labels = labels_map(result)

        # since this is using the compact algorithm with a high value for
        # compactness, the boundary between labels 1 and 2 should occur halfway
        # between the two markers
        @test sum(labels .== 1) == sum(1:50)
    end

    @testset "h-minima transform" begin
        img = ones(15, 15)
        #minima of depth 0.2
        img[3:5, 3:5] .= 0.9
        img[4,4] = 0.8
        #minima of depth 0.7
        img[9:13, 9:13] .= 0.8
        img[10:12, 10:12] .= 0.7
        img[11,11] = 0.3

        out = hmin_transform(img, 0.25)

        @test findlocalminima(img) == [CartesianIndex(4, 4), CartesianIndex(11, 11)]
        @test findlocalminima(out) == [CartesianIndex(11, 11)]
    end
end

@static if Base.VERSION <= v"1.0.5"
    # https://github.com/JuliaLang/julia/pull/29442
    _oneunit(::CartesianIndex{N}) where {N} = _oneunit(CartesianIndex{N})
    _oneunit(::Type{CartesianIndex{N}}) where {N} = CartesianIndex(ntuple(x -> 1, Val(N)))
else
    const _oneunit = Base.oneunit
end

# Once Base has colon defined here we can replace this
_colon(I::CartesianIndex{N}, J::CartesianIndex{N}) where N =
    CartesianIndices(map((i,j) -> i:j, Tuple(I), Tuple(J)))

@testset "Felzenszwalb" begin
    if Base.VERSION < v"1.4.0"
        _only(c) = (@assert length(c) == 1; c[1])
    else
        _only = only
    end

    img = zeros(Gray{N0f8}, 10, 10)
    img[2:3, 2:3] .= 0.2
    img[2, 8] = 0.5
    img[5:6, 5:6] .= 0.8
    T = Gray{N0f8}

    result = felzenszwalb(img, 1)

    @test length(result.segment_labels) == 4
    @test result.segment_labels == collect(1:4)

    @test all(label->(label==result.image_indexmap[2,2]), result.image_indexmap[2:3, 2:3])
    @test all(label->(label==result.image_indexmap[5,5]), result.image_indexmap[5:6, 5:6])

    TM = ImageSegmentation.meantype(T)
    @test result.segment_means[result.image_indexmap[1,1]] == zero(TM)
    @test result.segment_means[result.image_indexmap[2,2]] == TM(img[2,2])
    @test result.segment_means[result.image_indexmap[2,8]] == TM(img[2,8])
    @test result.segment_means[result.image_indexmap[5,5]] == TM(img[5,5])

    @test result.segment_pixel_count[result.image_indexmap[1,1]] == 91
    @test result.segment_pixel_count[result.image_indexmap[2,2]] == 4
    @test result.segment_pixel_count[result.image_indexmap[2,8]] == 1
    @test result.segment_pixel_count[result.image_indexmap[5,5]] == 4


    img = zeros(RGB{Float64}, 10, 10)
    img[2:3, 2:3] .= RGB(0.2,0.2,0.2)
    img[2, 8] = RGB(0.5,0.5,0.5)
    img[5:6, 5:6] .= RGB(0.8,0.8,0.8)
    T = RGB{Float64}
    TM = ImageSegmentation.meantype(T)

    result = felzenszwalb(img, 1, 2)

    @test length(result.segment_labels) == 3
    @test result.segment_labels == collect(1:3)

    @test result.image_indexmap[1, 1] == result.image_indexmap[2, 8]
    @test all(label->(label==result.image_indexmap[2,2]), result.image_indexmap[2:3, 2:3])
    @test all(label->(label==result.image_indexmap[5,5]), result.image_indexmap[5:6, 5:6])

    @test result.segment_means[result.image_indexmap[1,1]] ≈ RGB{Float64}(0.5/92, 0.5/92, 0.5/92)
    @test result.segment_means[result.image_indexmap[2,2]] == TM(img[2,2])
    @test result.segment_means[result.image_indexmap[5,5]] == TM(img[5,5])

    @test result.segment_pixel_count[result.image_indexmap[1,1]] == 92
    @test result.segment_pixel_count[result.image_indexmap[2,2]] == 4
    @test result.segment_pixel_count[result.image_indexmap[5,5]] == 4

    # issue 20
    img = falses(10, 10)
    img[2:3, 2:3] .= true
    img[2, 8] = true
    img[5:6, 5:6] .= true
    T = Bool
    TM = ImageSegmentation.meantype(T)

    result = felzenszwalb(img, 1, 2)

    @test length(result.segment_labels) == 3
    @test result.segment_labels == collect(1:3)

    @test result.image_indexmap[1, 1] == result.image_indexmap[2, 8]
    @test all(label->(label==result.image_indexmap[2,2]), result.image_indexmap[2:3, 2:3])
    @test all(label->(label==result.image_indexmap[5,5]), result.image_indexmap[5:6, 5:6])

    @test result.segment_means[result.image_indexmap[1,1]] ≈ 1/92
    @test result.segment_means[result.image_indexmap[2,2]] == TM(img[2,2])
    @test result.segment_means[result.image_indexmap[5,5]] == TM(img[5,5])

    @test result.segment_pixel_count[result.image_indexmap[1,1]] == 92
    @test result.segment_pixel_count[result.image_indexmap[2,2]] == 4
    @test result.segment_pixel_count[result.image_indexmap[5,5]] == 4

    img = falses(10, 10, 10)
    img[2:3, 2:3, 2:3] .= true
    img[5:6, 5:6, 5:6] .= true
    result = felzenszwalb(img, 1, 2)
    @test result.segment_labels == collect(1:3)
    ibkg = result.image_indexmap[1, 1, 1]
    i = _only(unique(result.image_indexmap[2:3, 2:3, 2:3]))
    @test i != ibkg
    result.image_indexmap[2:3, 2:3, 2:3] .= ibkg
    j = _only(unique(result.image_indexmap[5:6, 5:6, 5:6]))
    @test j != ibkg && j != i
    result.image_indexmap[5:6, 5:6, 5:6] .= ibkg
    @test all(==(ibkg), result.image_indexmap)
end

using ImageSegmentation
using ImageFiltering
using ImageCore.FixedPointNumbers, ImageCore.ColorTypes
using ImageMorphology: label_components
using Test

of_mean_type(p::Colorant) = ImageSegmentation.meantype(typeof(p))(p)

@testset "Seeded Region Growing" begin
    # 2-D image
    img = zeros(Gray{N0f8}, 10, 10)
    img[6:10,4:8] .= 0.5
    img[3:7,2:6] .= 0.8
    seeds = [CartesianIndex(3,9) => 1, CartesianIndex(5,2) => 2, CartesianIndex(9,7) => 3]

    expected = ones(Int, 10, 10)
    expected[6:10,4:8] .= 3
    expected[3:7,2:6] .= 2
    expected_labels = [1,2,3]
    expected_means = Dict(1 => of_mean_type(img[3,9]), 2 => of_mean_type(img[5,2]), 3 => of_mean_type(img[9,7]))
    expected_count = Dict(1 => 56, 2 => 25, 3 => 19)

    seg = seeded_region_growing(img, seeds)
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test expected_means == seg.segment_means
    @test seg.image_indexmap == expected

    # Custom neighbourhood using a function
    seg = seeded_region_growing(img, seeds, c->[CartesianIndex(c[1]-1,c[2]), CartesianIndex(c[1]+1,c[2]), CartesianIndex(c[1],c[2]-1), CartesianIndex(c[1],c[2]+1)])
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test expected_means == seg.segment_means
    @test seg.image_indexmap == expected

    # Offset image
    img = centered(img)
    seeds = [(CartesianIndex(-2,4),1), (CartesianIndex(0,-3),2), (CartesianIndex(4,2),3)]
    expected = centered(expected)
    seg = seeded_region_growing(img, seeds)
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test expected_means == seg.segment_means
    @test seg.image_indexmap == expected

    # Custom neighbourhood using a [3,3] vs [5,5] kernel
    img = zeros(Gray{N0f8}, 5, 5)
    img[2:4,2:4] .= 1
    img[3,3] = 0
    seeds = [(CartesianIndex(3,3),1), (CartesianIndex(2,3),2)]

    expected = fill(2,(5,5))
    expected[3,3] = 1
    expected_labels = [1,2]
    expected_means = Dict(1=>Gray{Float64}(0.0), 2=>Gray{Float64}(1/3))
    expected_count = Dict(1=>1, 2=>24)

    seg = seeded_region_growing(img, seeds, (3,3))
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test all(label->(expected_means[label] ≈ seg.segment_means[label]), seg.segment_labels)
    @test seg.image_indexmap == expected

    expected = ones(Int, 5, 5)
    expected[2:4,2:4] .= 2
    expected[3,3] = 1
    expected_labels = [1,2]
    expected_means = Dict(1=>Gray{N0f8}(0.0), 2=>Gray{N0f8}(1.0))
    expected_count = Dict(1=>17, 2=>8)

    seg = seeded_region_growing(img, seeds, (5,5))
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test expected_means == seg.segment_means
    @test seg.image_indexmap == expected

    # element-type and InexactError
    img = zeros(Int, 4, 4)
    img[2:end, 2:end] .= 10
    img[end,end] = 11
    seeds = [(CartesianIndex(1,1), 1), (CartesianIndex(2,2), 2)]

    expected = ones(Int, size(img))
    expected[2:end,2:end] .= 2
    expected_labels = [1,2]
    expected_means = Dict(1=>0.0, 2=>91/9)
    expected_count = Dict(1=>7, 2=>9)

    seg = seeded_region_growing(img, seeds, (3,3), (v1,v2)->(δ = abs(v1-v2); return δ > 1 ? δ : zero(δ)))
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test expected_means == seg.segment_means
    @test seg.image_indexmap == expected

    # changed mean and the same queues are in NHQ for several iterations
    # in this case the queue cannot just be inserted into pq several times
    img = Gray{N0f8}.([
     0.475  0.412  0.443  0.475  0.702  0.714  0.667  0.443  0.404  0.353
     0.525  0.431  0.365  0.424  0.682  0.698  0.635  0.365  0.329  0.318
     0.561  0.553  0.545  0.463  0.643  0.663  0.58   0.275  0.251  0.259
     0.561  0.588  0.655  0.639  0.694  0.62   0.537  0.263  0.184  0.184
     0.463  0.584  0.639  0.635  0.655  0.584  0.482  0.267  0.169  0.169
     0.263  0.263  0.541  0.557  0.58   0.522  0.431  0.243  0.145  0.145
     0.239  0.231  0.239  0.38   0.443  0.467  0.376  0.224  0.118  0.122
     0.263  0.212  0.153  0.325  0.404  0.471  0.349  0.22   0.106  0.106
     0.255  0.208  0.133  0.333  0.416  0.482  0.345  0.224  0.098  0.169
     0.235  0.18   0.102  0.294  0.369  0.447  0.325  0.22   0.122  0.184 ])

    expected = [
     1  1  1  1  1  1  1  1  1  2
     1  1  1  1  1  1  1  2  2  2
     1  1  1  1  1  1  1  2  2  2
     1  1  1  1  1  1  1  2  2  2
     1  1  1  1  1  1  1  2  2  2
     3  3  1  1  1  1  1  2  2  2
     3  3  3  3  1  1  2  2  2  2
     3  3  3  3  3  1  2  2  2  2
     3  3  3  3  3  1  2  2  2  2
     3  3  3  3  3  1  2  2  2  2]

    seeds = [ (CartesianIndex(1,5),1), (CartesianIndex(8,9),2), (CartesianIndex(9,3),3) ]
    seg = seeded_region_growing(img, seeds)
    @test seg.image_indexmap == expected

    # 3-d image
    img = zeros(RGB{N0f8},(9,9,9))
    img[3:7,3:7,3:7] .= RGB{N0f8}(0.5,0.5,0.5)
    img[2:5,5:9,4:6] .= RGB{N0f8}(0.8,0.8,0.8)
    seeds = [(CartesianIndex(1,1,1),1), (CartesianIndex(6,4,4),2), (CartesianIndex(3,6,5),3)]

    expected = ones(Int, (9,9,9))
    expected[3:7,3:7,3:7] .= 2
    expected[2:5,5:9,4:6] .= 3
    expected_labels = [1,2,3]
    expected_means = Dict([(i, of_mean_type(img[seeds[i][1]])) for i in 1:3])
    expected_count = Dict(1=>571, 2=>98, 3=>60)

    seg = seeded_region_growing(img, seeds)
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test expected_means == seg.segment_means
    @test seg.image_indexmap == expected

    # custom diff_fn
    img = zeros(RGB{N0f8},(3,3))
    img[1:3,1] .= RGB{N0f8}(0.4,1,0)
    img[1:3,2] .= RGB{N0f8}(0.2,1,0)
    seeds = [(CartesianIndex(2,1),1), (CartesianIndex(2,3),2)]

    expected = ones(Int, (3,3))
    expected[1:3,3] .= 2
    expected_labels = [1,2]
    expected_means = Dict(1=>RGB{Float32}(0.3,1.0,0.0), 2=>RGB{Float32}(0.0,0.0,0.0))
    expected_count = Dict(1=>6, 2=>3)

    seg = seeded_region_growing(img, seeds)
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test expected_means[1] ≈ seg.segment_means[1]
    @test expected_means[2] ≈ seg.segment_means[2]
    @test seg.image_indexmap == expected

    expected = ones(Int, (3,3))
    expected[1:3,2] .= 0
    expected[1:3,3] .= 2
    expected_labels = [0,1,2]
    expected_means = Dict(1=>RGB{Float32}(0.4,1.0,0.0), 2=>RGB{Float32}(0.0,0.0,0.0))
    expected_count = Dict(0=>3, 1=>3, 2=>3)

    seg = seeded_region_growing(img, seeds, (3,3), (c1,c2)->abs(of_mean_type(c1).r - of_mean_type(c2).r))
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test expected_means == seg.segment_means
    @test seg.image_indexmap == expected
    @info "The deprecation warning below is expected"   # but can be deleted eventually!
    segd = seeded_region_growing(img, seeds, [3,3], (c1,c2)->abs(of_mean_type(c1).r - of_mean_type(c2).r))
    @test labels_map(segd) == labels_map(seg)
end

@testset "Unseeded Region Growing" begin
    # 2-D image
    img = zeros(Gray{N0f8}, 10, 10)
    img[6:10,4:8] .= 0.5
    img[3:7,2:6] .= 0.8

    expected = ones(Int, 10, 10)
    expected[6:10,4:8] .= 2
    expected[3:7,2:6] .= 3
    expected_labels = [1,2,3]
    expected_means = Dict(1 => of_mean_type(img[3,9]), 3 => of_mean_type(img[5,2]), 2 => of_mean_type(img[9,7]))
    expected_count = Dict(1 => 56, 3 => 25, 2 => 19)

    seg = unseeded_region_growing(img, 0.2)
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test expected_means == seg.segment_means
    @test seg.image_indexmap == expected

    # Custom neighbourhood using a function
    seg = unseeded_region_growing(img, 0.2, c->[CartesianIndex(c[1]-1,c[2]), CartesianIndex(c[1]+1,c[2]), CartesianIndex(c[1],c[2]-1), CartesianIndex(c[1],c[2]+1)])
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test expected_means == seg.segment_means
    @test seg.image_indexmap == expected

    # Offset image
    img = centered(img)
    expected = centered(expected)
    seg = unseeded_region_growing(img, 0.2)
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test expected_means == seg.segment_means
    @test seg.image_indexmap == expected

    # Custom neighbourhood using a [5,5] kernel and varying threshold
    img = zeros(Gray{N0f8}, 5, 5)
    img[2:4,2:4] .= 1
    img[3,3] = 0.8

    expected = fill(1,(5,5))
    expected[2:4,2:4] .= 2
    expected_labels = [1,2]
    expected_means = Dict(1=>Gray{Float64}(0.0), 2=>Gray{Float64}(8.8/9))
    expected_count = Dict(2=>9, 1=>16)

    seg = unseeded_region_growing(img, 0.2, (5,5))
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test all(label->(expected_means[label] ≈ seg.segment_means[label]), seg.segment_labels)
    @test seg.image_indexmap == expected

    expected = ones(Int, 5, 5)
    expected[2:4,2:4] .= 3
    expected[3,3] = 2
    expected_labels = [1,2,3]
    expected_means = Dict(1=>Gray{N0f8}(0.0), 3=>Gray{N0f8}(1.0), 2=>Gray{N0f8}(0.8))
    expected_count = Dict(1=>16, 2=>1, 3=>8)

    seg = unseeded_region_growing(img, 0.1, (5,5))
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test expected_means == seg.segment_means
    @test seg.image_indexmap == expected

    expected = ones(Int, 5, 5)
    expected[2:4,2:4] .= 2
    expected[3,3] = 3
    expected_labels = [1,2,3]
    expected_means = Dict(1=>Gray{N0f8}(0.0), 2=>Gray{N0f8}(1.0), 3=>Gray{N0f8}(0.8))
    expected_count = Dict(1=>16, 3=>1, 2=>8)

    seg = unseeded_region_growing(img, 0.1, (3,3))
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test expected_means == seg.segment_means
    @test seg.image_indexmap == expected

    @test_throws ArgumentError unseeded_region_growing(img, NaN, (3,3))

    # 3-d image
    img = zeros(RGB{N0f8},(9,9,9))
    img[3:7,3:7,3:7] .= RGB{N0f8}(0.5,0.5,0.5)
    img[2:5,5:9,4:6] .= RGB{N0f8}(0.8,0.8,0.8)

    expected = ones(Int, (9,9,9))
    expected[3:7,3:7,3:7] .= 2
    expected[2:5,5:9,4:6] .= 3
    expected_labels = [1,2,3]
    expected_means = Dict(1=>of_mean_type(img[1,1,1]), 2=>of_mean_type(img[3,3,3]), 3=>of_mean_type(img[2,5,4]))
    expected_count = Dict(1=>571, 2=>98, 3=>60)

    seg = unseeded_region_growing(img, 0.2)
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test expected_means == seg.segment_means
    @test seg.image_indexmap == expected

    # custom diff_fn
    img = zeros(RGB{N0f8},(3,3))
    img[1:3,1] .= RGB{N0f8}(0.4,1,0)
    img[1:3,2] .= RGB{N0f8}(0.2,1,0)

    expected = ones(Int, (3,3))
    expected[1:3,2] .= 2
    expected[1:3,3] .= 3
    expected_labels = [1,2,3]
    expected_means = Dict(1=>of_mean_type(img[1,1]), 3=>of_mean_type(img[1,3]), 2=>of_mean_type(img[1,2]))
    expected_count = Dict(1=>3, 2=>3, 3=>3)

    seg = unseeded_region_growing(img, 0.2, (3,3), (c1,c2)->abs(of_mean_type(c1).r - of_mean_type(c2).r))
    @test all(label->(label in expected_labels), seg.segment_labels)
    @test all(label->(label in seg.segment_labels), expected_labels)
    @test expected_count == seg.segment_pixel_count
    @test expected_means == seg.segment_means
    @test seg.image_indexmap == expected
    @info "The deprecation warning below is expected"   # but can be deleted eventually!
    segd = unseeded_region_growing(img, 0.2, [3,3], (c1,c2)->abs(of_mean_type(c1).r - of_mean_type(c2).r))
    @test labels_map(segd) == labels_map(seg)

    # Obtaining contiguous regions by calling label_components
    # and then building a new SegmentedImage
    c1, c2 = RGB{N0f8}(0.4,1,0), RGB{N0f8}(1,0.3,0.7)
    img = [c1 c1 c1 c2 c2 c1 c1 c1;
           c1 c1 c2 c2 c2 c2 c1 c1;
           c1 c1 c1 c2 c2 c1 c1 c1;
    ]
    seg = unseeded_region_growing(img, 0.2)
    @test length(segment_labels(seg)) == 2
    L = label_components(labels_map(seg))
    function labelgt(idx)
        img[idx] == c2 && return 2
        idx[2] < 5 && return 1
        return 3
    end
    @test L == labelgt.(CartesianIndices(img))
    seg = SegmentedImage(img, L)
    @test length(segment_labels(seg)) == 3
    @test labels_map(seg) == L
    @test segment_mean(seg, 1) ≈ c1
    @test segment_mean(seg, 2) ≈ c2
    @test segment_mean(seg, 3) ≈ c1
    @test segment_pixel_count(seg) == Dict(1=>8, 2=>8, 3=>8)
end

"""
    seg_img = seeded_region_growing(img, seeds, [kernel_dim], [diff_fn])
    seg_img = seeded_region_growing(img, seeds, [neighbourhood], [diff_fn])

Segments the N-D image `img` using the seeded region growing algorithm
and returns a [`SegmentedImage`](@ref) containing information about the segments.

# Arguments:
* `img`             :  N-D image to be segmented (arbitrary axes are allowed)
* `seeds`           :  `Vector` containing seeds. Each seed is a Tuple of a
                       CartesianIndex{N} and a label. See below note for more
                       information on labels.
* `kernel_dim`      :  (Optional) `Vector{Int}` having length N or a `NTuple{N,Int}`
                       whose ith element is an odd positive integer representing
                       the length of the ith edge of the N-orthotopic neighbourhood
* `neighbourhood`   :  (Optional) Function taking CartesianIndex{N} as input and
                       returning the neighbourhood of that point.
* `diff_fn`         :  (Optional) Function that returns a difference measure(δ)
                       between the mean color of a region and color of a point

!!! note
    The labels attached to points must be positive integers, although multiple
    points can be assigned the same label. The output includes a labelled array
    that has same indexing as that of input image. Every index is assigned to
    either one of labels or a special label '0' indicating that the algorithm
    was unable to assign that index to a unique label.

# Examples

```jldoctest; setup = :(using ImageCore, ImageMorphology,ImageSegmentation)
julia> img = zeros(Gray{N0f8},4,4);

julia> img[2:4,2:4] .= 1;

julia> seeds = [(CartesianIndex(3,1),1),(CartesianIndex(2,2),2)];

julia> seg = seeded_region_growing(img, seeds);

julia> labels_map(seg)
4×4 $(Matrix{Int}):
 1  1  1  1
 1  2  2  2
 1  2  2  2
 1  2  2  2
```

# Citation:

Albert Mehnert, Paul Jackaway (1997), "An improved seeded region growing algorithm",
Pattern Recognition Letters 18 (1997), 1065-1071
"""
function seeded_region_growing(img::AbstractArray{CT,N}, seeds::AbstractVector{<:PairOrTuple{CartesianIndex{N},Int}},
    kernel_dim::Dims{N} = ntuple(i->3,N), diff_fn::Function = default_diff_fn) where {CT<:Union{Colorant,Real}, N}
    seeded_region_growing(img, seeds, box_iterator(kernel_dim), diff_fn)
end

function seeded_region_growing(img::AbstractArray{CT,N}, seeds::AbstractVector{<:PairOrTuple{CartesianIndex{N},Int}},
    neighbourhood::NF, diff_fn::DF = default_diff_fn) where {CT<:Union{Colorant,Real}, N, NF<:Function, DF<:Function}

    # Check if labels are positive integers
    for seed in seeds
        seed[2] > 0 || error("Seed labels need to be positive integers!")
    end

    TM = meantype(CT)

    # Fast linear<->cartesian indexing lookup
    cil = reshape(CartesianIndices(img), :)
    lic = LinearIndices(img)

    # Required data structures
    result              =   fill(-1, axes(img))                                     # Array to store labels
    nhq                 =   CartesianIndex{N}[]                                     # Neighbours holding queue
    pq                  =   PriorityQueue{Int, Float32}()                           # Priority Queue for differences
    holdingq            =   Pair{CartesianIndex{N},Int}[]                           # Ready-to-assign labels
    region_means        =   Dict{Int, TM}()                                         # A map containing (label, mean) pairs
    region_pix_count    =   Dict{Int, Int}()                                        # A map containing (label, pixel_count) pairs
    labels              =   Int[]                                                   # A vector containing list of labels

    # Labelling initial seeds and initialising `region_means` and `region_pix_count`
    for (p, idx) in seeds
        result[p] = idx
        region_pix_count[idx] = get(region_pix_count, idx, 0) + 1
        region_means[idx] = get(region_means, idx, zero(TM)) + (img[p] - get(region_means, idx, zero(TM)))/(region_pix_count[idx])
        if idx ∉ labels
            push!(labels, idx)
        end
    end

    #=  Labeling scheme for the Array "result"-
            Unlabelled => -1
            In nhq => -2
            In pq => -3
            Tied => 0
            Labelled => Seed value
    =#

    # Enqueue all the neighbours of seeds into `nhq`
    for (p, _) in seeds
        for point in neighbourhood(p)
            if point != p && checkbounds(Bool, img, point) && result[point] == -1
                push!(nhq, point)
                @inbounds result[point] = -2
            end
        end
    end

    while !isempty(pq) || !isempty(nhq)

        for p in nhq
            # For every neighbouring point, get the minimum δ
            @inbounds imgp = img[p]
            δ = Inf
            for point in neighbourhood(p)
                if point != p && checkbounds(Bool, img, point)
                    @inbounds r = result[point]
                    if r > 0
                        curr_diff = diff_fn(region_means[r], imgp)
                        δ = min(δ, curr_diff)
                    end
                end
            end
            pq[lic[p]] = δ
            @inbounds result[p] = -3
        end
        empty!(nhq)

        # Get the pixels with minimum δ from `pq` and add them to `holdingq` and their labels to `labelsq`
        if !isempty(pq)
            δ_min = first(pq)[2]
        end
        while (!isempty(pq) && isapprox(first(pq)[2], δ_min)) #, atol=1e-8))
            p = cil[popfirst!(pq)[1]]
            @assert result[p] <= 0
            @inbounds imgp = img[p]
            mindifflabel = -1
            mindiff = Inf
            for point in neighbourhood(p)
                if point!=p && checkbounds(Bool, img, point)
                    @inbounds r = result[point]
                    if r > 0
                        if mindifflabel < 0
                            mindifflabel = r
                            mindiff = diff_fn(region_means[r], imgp)
                        elseif mindifflabel != r
                            curr_diff = diff_fn(region_means[r], imgp)
                            if curr_diff < mindiff
                                mindiff = curr_diff
                                mindifflabel = r
                            elseif isapprox(curr_diff, mindiff) #, atol=1e-8)
                                mindifflabel = 0
                            end
                        end
                    end
                end
            end
            if mindifflabel != 0                # new labels, including resolved ties in last step
                push!(holdingq, p=>mindifflabel)
                @inbounds result[p] = -2
            elseif result[p] == -3              # new ties are enqueued in pq
                pq[lic[p]] = Inf
                result[p] = 0
            end                                 # old ties are not enqueued again
        end

        # Add label to each point in `holdingq` and add their neighbours to `nhq`
        for (p, label) in holdingq
            @inbounds begin
                result[p] = label
                region_pix_count[label] += 1
                region_means[label] += (img[p] - region_means[label])/(region_pix_count[label])
            end
            for point in neighbourhood(p)
                if point != p && checkbounds(Bool, img, point)
                    @inbounds begin
                        r = result[point]
                        if r == -1 || r == -3
                            push!(nhq, point)
                            result[point] = -2
                        end
                    end
                end
            end
        end
        empty!(holdingq)

    end

    c0 = count(i->(i==0),result)
    if c0 != 0
        push!(labels, 0)
        region_pix_count[0] = c0
    end
    SegmentedImage(result, labels, region_means, region_pix_count)
end


"""
    seg_img = unseeded_region_growing(img, threshold, [kernel_dim], [diff_fn])
    seg_img = unseeded_region_growing(img, threshold, [neighbourhood], [diff_fn])

Segments the N-D image using automatic (unseeded) region growing algorithm
and returns a [`SegmentedImage`](@ref) containing information about the segments.

# Arguments:
* `img`             :  N-D image to be segmented (arbitrary axes are allowed)
* `threshold`       :  Upper bound of the difference measure (δ) for considering
                       pixel as the same segment
* `kernel_dim`      :  (Optional) `Vector{Int}` having length N or a `NTuple{N,Int}`
                       whose ith element is an odd positive integer representing
                       the length of the ith edge of the N-orthotopic neighbourhood
* `neighbourhood`   :  (Optional) Function taking CartesianIndex{N} as input and
                       returning the neighbourhood of that point.
* `diff_fn`         :  (Optional) Function that returns a difference measure (δ)
                       between the mean color of a region and color of a point

# Examples

```jldoctest; setup = :(using ImageCore, ImageMorphology, ImageSegmentation)
julia> img = zeros(Gray{N0f8},4,4);

julia> img[2:4,2:4] .= 1;

julia> seg = unseeded_region_growing(img, 0.2);

julia> labels_map(seg)
4×4 $(Matrix{Int}):
 1  1  1  1
 1  2  2  2
 1  2  2  2
 1  2  2  2
```

"""
function unseeded_region_growing(img::AbstractArray{CT,N}, threshold::Real,
    kernel_dim::Dims{N} = ntuple(i->3,N), diff_fn::Function = default_diff_fn) where {CT<:Colorant, N}
    unseeded_region_growing(img, threshold, box_iterator(kernel_dim), diff_fn)
end

function unseeded_region_growing(img::AbstractArray{CT,N}, threshold::Real, neighbourhood::Function, diff_fn::Function = default_diff_fn) where {CT<:Colorant,N}
    isnan(threshold) && throw(ArgumentError("The threshold can't be a NaN value, it'll result in an instance per pixel"))
    TM = meantype(CT)

    # Fast linear<->cartesian indexing lookup
    cil = reshape(CartesianIndices(img), :)
    lic = LinearIndices(img)

    # Required data structures
    result                  =   fill(-1, axes(img))                             # Array to store labels
    neighbours              =   PriorityQueue{Int,Float32}()                    # Priority Queue containing boundary pixels with δ as the priority
    region_means            =   Dict{Int, TM}()                                 # A map containing (label, mean) pairs
    region_pix_count        =   Dict{Int, Int}()                                # A map containing (label, pixel_count) pairs
    labels                  =   Vector{Int}()                                   # Vector containing assigned labels

    # Initialize data structures
    start_point = first(CartesianIndices(axes(img)))
    result[start_point] = 1
    push!(labels, 1)
    region_means[1] = img[start_point]
    region_pix_count[1] = 1

    # Enqueue neighouring points of `start_point`
    for p in neighbourhood(start_point)
        if p != start_point && checkbounds(Bool, img, p) && result[p] == -1
            push!(neighbours, lic[p] => diff_fn(region_means[result[start_point]], img[p]))
        end
    end

    while !isempty(neighbours)
        point = cil[popfirst!(neighbours)[1]]
        δ = Inf
        minlabel = -1
        pixelval = img[point]
        for p in neighbourhood(point)
            if p != point && checkbounds(Bool, img, p) && result[p] > 0
                curδ = diff_fn(region_means[result[p]], pixelval)
                if curδ < δ
                    δ = curδ
                    minlabel = result[p]
                end
            end
        end

        if δ < threshold
            # Assign point to minlabel
            result[point] = minlabel
        else
            # Select most appropriate label
            δ = Inf
            minlabel = -1
            for label in labels
                curδ = diff_fn(region_means[label], pixelval)
                if curδ < δ
                    δ = curδ
                    minlabel = label
                end
            end

            if δ < threshold
                result[point] = minlabel
            else
                # Assign point to a new label
                minlabel = length(labels) + 1
                push!(labels, minlabel)
                result[point] = minlabel
            end
        end

        #Update region_means
        region_pix_count[minlabel] = get(region_pix_count, minlabel, 0) + 1
        region_means[minlabel] = get(region_means, minlabel, zero(TM)) + (pixelval - get(region_means, minlabel, zero(TM)))/(region_pix_count[minlabel])

        # Enqueue neighbours of `point`
        for p in neighbourhood(point)
            if checkbounds(Bool, img, p) && result[p] == -1
                if haskey(neighbours, lic[p])
                    continue
                end
                δ = Inf
                for tp in neighbourhood(p)
                    if checkbounds(Bool, img, tp) && tp != p && result[tp] > 0
                        δ = min(δ, diff_fn(region_means[result[tp]], img[p]))
                    end
                end
                push!(neighbours, lic[p] => δ)
            end
        end

    end
    SegmentedImage(result, labels, region_means, region_pix_count)
end

"""
    mask = flood(f, src, idx, nbrhood_function=diamond_iterator((3,3,...)))

Return an array `mask` with the same axes as `src`, marked `true` for all elements of `src` that:

- satisfy `f(src[i]) == true` and
- are connected by such elements to the starting point `idx` (an integer index or `CartesianIndex`).

This throws an error if `f` evaluates as `false` for the starting value `src[idx]`.
The sense of connectivity is defined by `nbrhood_function`, with two choices being
[`ImageSegmentation.diamond_iterator`](@ref) and [`ImageSegmentation.box_iterator`](@ref.)

# Examples

```jldoctest; setup=:(using ImageSegmentation, ImageCore)
julia> mostly_red(c) = red(c) > green(c) && red(c) > blue(c)
mostly_red (generic function with 1 method)

julia> img = repeat(LinRange(colorant"red", colorant"blue", 4), 1, 2) # red-to-blue
4×2 Matrix{RGB{Float32}}:
 RGB(1.0, 0.0, 0.0)            RGB(1.0, 0.0, 0.0)
 RGB(0.666667, 0.0, 0.333333)  RGB(0.666667, 0.0, 0.333333)
 RGB(0.333333, 0.0, 0.666667)  RGB(0.333333, 0.0, 0.666667)
 RGB(0.0, 0.0, 1.0)            RGB(0.0, 0.0, 1.0)

julia> flood(mostly_red, [img; img], 1)   # only first copy of `img` is connected
8×2 BitMatrix:
 1  1
 1  1
 0  0
 0  0
 0  0
 0  0
 0  0
 0  0
```

See also [`flood_fill!`](@ref).
"""
flood(f, src::AbstractArray, idx::Union{Integer,CartesianIndex}, nbrhood_function=diamond_iterator(window_neighbors(src))) =
    flood_fill!(f, falses(axes(src)) #=fill!(similar(src, Bool), false)=#, src, idx, nbrhood_function)

"""
    mask = flood(src, idx, nbrhood_function=diamond_iterator((3,3,...)); thresh)

Return an array `mask` with the same axes as `src`, marked `true` for all connected elements
of `src` for which `src[i]` has a Euclidean distance less than `thresh` from `src[idx]`.
"""
function flood(src::AbstractArray, idx::Union{Integer,CartesianIndex},
                    nbrhood_function=diamond_iterator(window_neighbors(src)); thresh)
    validx = src[idx]
    validx = accum_type(typeof(validx))(validx)
    return let validx=validx
        flood(val -> default_diff_fn(val, validx) < thresh, src, idx, nbrhood_function)
    end
end

"""
    flood_fill!(f, dest, src, idx, nbrhood_function=diamond_iterator((3,3,...)); fillvalue=true, isfilled = isequal(fillvalue))

Set entries of `dest` to `fillvalue` for all elements of `src` that:

- satisfy `f(src[i]) == true` and
- are connected by such elements to the starting point `idx` (an integer index or `CartesianIndex`).

This throws an error if `f` evaluates as `false` for the starting value `src[idx]`.
The sense of connectivity is defined by `nbrhood_function`, with two choices being
[`ImageSegmentation.diamond_iterator`](@ref) and [`ImageSegmentation.box_iterator`](@ref.)

You can optionally omit `dest`, in which case entries in `src` will be set to `fillvalue`.
This is recommended only in cases where `fillvalue` is distinct from the values in `src`,
as otherwise there is a risk that some voxels will be incorrectly identified as having been
visited and their neighbors excluded from further search.
You may also supply `isfilled`, which should return `true` for any value in `dest`
which does not need to be set or visited; one requirement is that `isfilled(fillvalue) == true`.

# Examples

```jldoctest; setup=:(using ImageSegmentation)
julia> a = repeat([1:4; 1:4], 1, 3)
8×3 Matrix{Int64}:
 1  1  1
 2  2  2
 3  3  3
 4  4  4
 1  1  1
 2  2  2
 3  3  3
 4  4  4

julia> flood_fill!(>=(3), a, CartesianIndex(3, 2); fillvalue = -1, isfilled = <(0))
8×3 Matrix{Int64}:
  1   1   1
  2   2   2
 -1  -1  -1
 -1  -1  -1
  1   1   1
  2   2   2
  3   3   3
  4   4   4
```

See also [`flood`](@ref).
"""
function flood_fill!(f,
                     dest,
                     src::AbstractArray,
                     idx::Union{Int,CartesianIndex},
                     nbrhood_function = diamond_iterator(window_neighbors(src));
                     fillvalue = true,
                     isfilled = (fillvalue === true) ? identity : isequal(fillvalue))
    R = CartesianIndices(src)
    idx = R[idx]  # ensure cartesian indexing
    f(src[idx]) || throw(ArgumentError("starting point fails to meet criterion"))
    q = [idx]
    fillvalue = convert(eltype(dest), fillvalue)
    axes(dest) == R.indices || throw(DimensionMismatch("$(axes(dest)) do not match $(Tuple(R))"))
    _flood_fill!(f, dest, src, R, q, nbrhood_function, fillvalue, isfilled)
    return dest
end
flood_fill!(f, dest, src::AbstractArray, idx::Integer, args...; kwargs...) =
    flood_fill!(f, dest, src, Int(idx)::Int, args...; kwargs...)
flood_fill!(f, src::AbstractArray, idx::Union{Integer,CartesianIndex}, args...; kwargs...) =
    flood_fill!(f, src, src, idx, args...; kwargs...)

# This is a trivial implementation (just to get something working), better would be a raster implementation
function _flood_fill!(f::F, dest, src, R::CartesianIndices{N}, q, nbrhood_function::FN, fillvalue, isfilled::C) where {F,N,FN,C}
    isfilled(fillvalue) == true || throw(ArgumentError("`isfilled(fillvalue)` must return `true`"))
    if Base.mightalias(dest, src)
        try
            f(fillvalue) && @warn """
                in-place `fillvalue` may not be distinct from array values, and filling may be incomplete.
                To suppress this warning, avoid filling in-place or ensure `f(fillvalue)` is `false`."""
        catch
        end
    end
    while !isempty(q)
        idx = pop!(q)
        dest[idx] = fillvalue
        @inbounds for j in nbrhood_function(idx)
            j ∈ R || continue
            if f(src[j]) && !isfilled(dest[j])
                push!(q, j)
            end
        end
    end
end

sharpness(img::AbstractArray{CT,N}) where {CT<:ImageCore.NumberLike,N} = var(imfilter(img, Kernel.Laplacian(ntuple(i->true, Val(N)))))

function adaptive_thres(img::AbstractArray{CT,N}, block::NTuple{N,Int}) where {CT<:ImageCore.NumberLike,N}
    threshold = zeros(Float64, block)
    block_length = CartesianIndex(ntuple(i->ceil(Int,length(axes(img,i))/block[i]),Val(N)))
    net_s = sharpness(img)
    net_var = var(img)
    net_end = last(CartesianIndices(axes(img)))
    for i in CartesianIndices(block)
        si = CartesianIndex(ntuple(j->(i[j]-1)*block_length[j]+1,Val(N)))
        ei = min(si + block_length - _oneunit(si), net_end)
        wi = view(img, map((i,j)->i:j, si.I, ei.I)...)
        threshold[i] = 0.02 + min(sharpness(wi)/net_s*0.04,0.1) + min(var(wi)/net_var*0.04,0.1)
    end
    threshold
end

getscalar(A::AbstractArray{T,N}, i::CartesianIndex{N}, block_length::CartesianIndex{N}) where {T<:Real,N} =
    A[CartesianIndex(ntuple(j->(i[j]-1)÷block_length[j]+1, Val(N)))]

getscalar(a::Real, i...) = a

"""
    seg_img = fast_scanning(img, threshold, [diff_fn])

Segments the N-D image using a fast scanning algorithm and returns a
[`SegmentedImage`](@ref) containing information about the segments.

# Arguments:
* `img`         : N-D image to be segmented (arbitrary axes are allowed)
* `threshold`   : Upper bound of the difference measure (δ) for considering
                  pixel into same segment; an `AbstractArray` can be passed
                  having same number of dimensions as that of `img` for adaptive
                  thresholding
* `diff_fn`     : (Optional) Function that returns a difference measure (δ)
                  between the mean color of a region and color of a point

# Examples:

```jldoctest; setup = :(using ImageCore, ImageMorphology, ImageSegmentation)
julia> img = zeros(Float64, (3,3));

julia> img[2,:] .= 0.5;

julia> img[:,2] .= 0.6;

julia> seg = fast_scanning(img, 0.2);

julia> labels_map(seg)
3×3 $(Matrix{Int}):
 1  4  5
 4  4  4
 3  4  6
```

# Citation:

Jian-Jiun Ding, Cheng-Jin Kuo, Wen-Chih Hong,
"An efficient image segmentation technique by fast scanning and adaptive merging"
"""
fast_scanning(img::AbstractArray{CT,N}, block::NTuple{N,Int} = ntuple(i->4,Val(N))) where {CT<:ImageCore.NumberLike,N} =
    fast_scanning(img, adaptive_thres(img, block))

fast_scanning(img::AbstractArray{CT,N}, threshold::Union{AbstractArray,Real}, diff_fn::Function = default_diff_fn) where {CT<:Union{Colorant,Real},N} =
    fast_scanning!(fill(-1, axes(img)), img, threshold, diff_fn)

function fast_scanning!(result, img::AbstractArray{CT,N}, threshold::Union{AbstractArray,Real}, diff_fn::DF = default_diff_fn) where {CT<:Union{Colorant,Real},N,DF<:Function}
    if threshold isa AbstractArray
        ndims(img) == ndims(threshold) || error("Dimension count of image and threshold do not match")
    end

    # Neighbourhood function
    _diagmN = Diagonal([1 for i in 1:N])
    half_region::NTuple{N,CartesianIndex{N}} = ntuple(i-> CartesianIndex{N}(ntuple(j->_diagmN[j,i], Val(N))), Val(N))
    neighbourhood(x) = ntuple(i-> x-half_region[i], Val(N))

    # Required data structures
    TM = meantype(CT)
    region_means        =   Dict{Int, TM}()                                 # A map conatining (label, mean) pairs
    region_pix_count    =   Dict{Int, Int}()                                # A map conatining (label, count) pairs
    temp_labels         =   IntDisjointSets(0)                              # Disjoint set to map labels to their equivalence class
    v_neigh             =   MVector{N,Int}(undef)                           # MVector to store valid neighbours

    block_length = CartesianIndex(ntuple(i->ceil(Int,length(axes(img,i))/size(threshold,i)), Val(N)))

    for point in CartesianIndices(axes(img))
        sz = 0
        same_label = true
        prev_label = 0
        for p in neighbourhood(point)
            if checkbounds(Bool, img, p)
                root_p = find_root!(temp_labels, result[p])
                if diff_fn(region_means[root_p], img[point]) < getscalar(threshold, point, block_length)
                    if prev_label == 0
                        prev_label = root_p
                    elseif prev_label != root_p
                        same_label = false
                    end
                    sz += 1
                    v_neigh[sz] = find_root!(temp_labels, root_p)
                end
            end
        end

        # If no valid label found
        if sz == 0
            # Assign a new label
            new_label = push!(temp_labels)
            result[point] = new_label
            region_means[new_label] = img[point]
            region_pix_count[new_label] = 1

        # If all labels are same
        elseif same_label
            result[point] = prev_label
            region_pix_count[prev_label] += 1
            region_means[prev_label] += (img[point] - region_means[prev_label])/(region_pix_count[prev_label])
        else
            # Merge segments and assign to this new label
            union_label = v_neigh[1]
            for i in 1:sz
                union_label = union!(temp_labels, union_label, v_neigh[i])
            end
            result[point] = union_label
            region_pix_count[union_label] += 1
            region_means[union_label] += (img[point] - region_means[union_label])/(region_pix_count[union_label])

            for i in 1:sz
                if v_neigh[i] != union_label && haskey(region_pix_count, v_neigh[i])
                    region_pix_count[union_label] += region_pix_count[v_neigh[i]]
                    region_means[union_label] += (region_means[v_neigh[i]] - region_means[union_label])*region_pix_count[v_neigh[i]]/region_pix_count[union_label]

                    # Remove label v_neigh[i] from region_means, region_pix_count
                    delete!(region_pix_count,v_neigh[i])
                    delete!(region_means,v_neigh[i])
                end
            end
        end
    end

    for point in CartesianIndices(axes(img))
        result[point] = find_root!(temp_labels, result[point])
    end

    SegmentedImage(result, unique(temp_labels.parents), region_means, region_pix_count)
end

import Base.isless

struct PixelKey{CT, N}
    val::CT
    time_step::Int
    source::CartesianIndex{N}
end
isless(a::PixelKey, b::PixelKey) = (a.val < b.val) || (a.val == b.val && a.time_step < b.time_step)

"""Calculate the euclidean distance between two `CartesianIndex` structs"""
@inline _euclidean(a::CartesianIndex{N}, b::CartesianIndex{N}) where {N} = sqrt(sum(Tuple(a - b) .^ 2))

"""
```
segments                = watershed(img, markers; compactness, mask)
```
Segments the image using watershed transform. Each basin formed by watershed transform corresponds to a segment.
If you are using image local minimas as markers, consider using [`hmin_transform`](@ref) to avoid oversegmentation.

Parameters:
-    img            = input grayscale image
-    markers        = An array (same size as img) with each region's marker assigned a index starting from 1. Zero means not a marker.
                      If two markers have the same index, their regions will be merged into a single region.
                      If you have markers as a boolean array, use `label_components`.
-    compactness    = Use the compact watershed algorithm with the given compactness parameter. Larger values lead to more regularly
                      shaped watershed basins.[^1]
-    mask           = Only segment pixels where the value of `mask` is true, used to restrict segmentation to only areas of interest


[^1]: https://www.tu-chemnitz.de/etit/proaut/publications/cws_pSLIC_ICPR.pdf

# Example

```jldoctest; setup = :(using ImageCore, ImageMorphology, ImageSegmentation)
julia> seeds = falses(100, 100); seeds[50, 25] = true; seeds[50, 75] = true;

julia> dists = distance_transform(feature_transform(seeds)); # calculate distances from seeds

julia> markers = label_components(seeds); # give each seed a unique integer id

julia> results = watershed(dists, markers);

julia> labels_map(results); # labels of segmented image
```
"""
function watershed(img::AbstractArray{T, N},
                   markers::AbstractArray{S,N};
                   mask::AbstractArray{Bool, N}=fill(true, axes(img)),
                   compactness::Real = 0.0) where {T<:ImageCore.NumberLike, S<:Integer, N}

    if axes(img) != axes(markers)
        error("image size doesn't match marker image size")
    elseif axes(img) != axes(mask)
        error("image size doesn't match mask size")
    end

    compact = compactness > 0.0
    segments = copy(markers)
    PK = PixelKey{compact ? floattype(T) : T, N}
    pq = PriorityQueue{CartesianIndex{N}, PK}()
    time_step = 0

    R = CartesianIndices(axes(img))
    Istart, Iend = first(R), last(R)
    for i in R
        if markers[i] > 0
            for j in _colon(max(Istart,i-_oneunit(i)), min(i+_oneunit(i),Iend))
                if segments[j] == 0
                    segments[j] = markers[i]
                    enqueue!(pq, j, PK(img[i], time_step, j))
                    time_step += 1
                end
            end
        end
    end

    while !isempty(pq)
        curr_idx, curr_elem = dequeue_pair!(pq)
        segments_current = segments[curr_idx]

        # If we're using the compact algorithm, we need assign grouping for a given location
        # when it comes off the queue since we could find a better suited watershed later.
        if compact
            if segments_current > 0 && curr_idx != curr_elem.source
                # this is a non-marker location that we've already assigned
                continue
            end
            # group this location with its watershed
            segments[curr_idx] = segments[curr_elem.source]
        end

        img_current = img[curr_idx]
        for j in _colon(max(Istart,curr_idx-_oneunit(curr_idx)), min(curr_idx+_oneunit(curr_idx),Iend))

            # if this location is false in the mask, we skip it
            (!mask[j]) && continue
            # only continue if this is a position that we haven't assigned yet
            if segments[j] == 0
                # if we're doing a simple watershed, we can go ahead and set the final grouping for a new
                # ungrouped position the moment we first encounter it
                if !compact
                    segments[j] = segments_current
                    new_value = img_current
                else
                    # in the compact algorithm case, we don't set the grouping
                    # at push-time and instead calculate a temporary value based
                    # on the weighted sum of the intensity and distance to the
                    # current source marker.
                    new_value = floattype(T)(img_current + compactness * _euclidean(j, curr_elem.source))
                end

                # if this position is in the queue and we're using the compact algorithm, we need to replace
                # its watershed if we find one that it better belongs to
                if compact && j in keys(pq)
                    elem = pq[j]
                    new_elem = PK(new_value, time_step, curr_elem.source)

                    if new_elem < elem
                        pq[j] = new_elem # update the watershed
                        time_step += 1
                    end
                else

                    pq[j] = PK(new_value, time_step, curr_elem.source)
                    time_step += 1
                end
            end
        end
    end

    TM = meantype(T)
    num_segments        = Int(maximum(segments))
    labels              = Array(1:num_segments)
    region_means        = Dict{Int, TM}()
    region_pix_count    = Dict{Int, Int}()

    for i in R
        region_pix_count[segments[i]] = get(region_pix_count, segments[i], 0) + 1
        region_means[segments[i]] = get(region_means, segments[i], zero(TM)) + (img[i] - get(region_means, segments[i], zero(TM)))/region_pix_count[segments[i]]
    end
    return SegmentedImage(segments, labels, region_means, region_pix_count)
end

"""
```
out = hmin_transform(img, h)
```
Suppresses all minima in grayscale image whose depth is less than h.

H-minima transform is defined as the reconstruction by erosion of (img + h) by img. See Morphological image analysis by Soille pg 170-172.
"""
function hmin_transform(img::Array{T, N}, h::Real) where {T<:ImageCore.NumberLike, N}
    out = img.+h
    while true
        temp = max.(img, erode(out))
        if temp == out
            break
        end
        out = temp
    end
    return out
end
